/*
 * Image.h
 *
 *  Created on: 11/12/2012
 *      Author: sharma
 */

#ifndef IMAGE_H_
#define IMAGE_H_

#include "Mat.h"
#include "ebf.hpp"


class Image
{
public:
	std::vector<double> im;
	double xmin[6],xmax[6],dx,hl,r,fep;
	int ixmin[6],ixmax[6];
	int w,dim;
	Mat mt;
	~Image();
	Image(int dim1):dim(dim1),mt(dim1,0)
	{

	}
	void init(double xc,double yc,double zc,double length,int pixels)
	{
		float fepanech[]=
		{ 0.75000113, 0.63661975, 0.59683102, 0.60792705, 0.66492015, 0.77403670,
				0.95242788, 1.2319173, 1.6674189, 2.3527875, 3.4499109, 5.2424031,
				8.2360444, 13.349647, 22.283674, 38.243824, 67.384374, 121.73344,
				225.21478, 426.23651 };
		w=pixels;
		xmin[0]=xc-length/2;
		xmin[1]=yc-length/2;
		xmin[2]=zc-length/2;
		xmax[0]=xc+length/2;
		xmax[1]=yc+length/2;
		xmax[2]=zc+length/2;
		int nsize=1;
		for(int j=0;j<dim;++j)
			nsize*=w;
		im.resize(nsize,0.0);
		dx=(length)/(w-1);
		fep=fepanech[dim-1];
		if((dim<2)||(dim>3))
		{
			std::cout<<"Dim must be 2<=dim<=3"<<std::endl;
			exit(1);
		}
	}
	void update(double* Pos,double* metric,double factor);
	void updateR(double* Pos,double* matrixa,double factor);
	void write(const std::string& outfile);
	void writeascii(const std::string& outfile);

};



#endif /* IMAGE_H_ */
