//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef KERNEL_H_
#define KERNEL_H_
//#include "sutils.h"
//#include "Particle.h"
#include "ParticlePriorityQueue.h"

class Kernel
{
public:
	Kernel(int size1, int dim1, int TypeOfKernel1,bool biasCorrectionOn1,int scatterOn1);
	~Kernel();
	void setKernel(int TypeOfKernel);
	double computeDensityGen(ParticlePriorityQueue &pq,double* metric,int items);
	void computeDensity(Particle* Part,ParticlePriorityQueue &pq,double* metric,int items);
	void computeDensityS(Particle* Part,ParticlePriorityQueue &pq,double* metric,int items);
	void computeDensityN(Particle* Part,ParticlePriorityQueue &pq,double* metric,int items,int N);
//	double computeK(double u);
	inline double computeK(double u)
	{
		return (1-u*u);
//		u=u*(size-2);
//		int i=int(u);
//		return (ky[i]+(ky[i+1]-ky[i])*(u-i));
	}
public:
	std::vector<double> ky;
	int biasCorrectionOn,scatterOn;
	double fd;
	double epsilon;
	int dim;
	int size;
	double w_corr;
	double dx;
};

#endif /*KERNEL_H_*/
