//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================

#ifndef MAT_H_
#define MAT_H_
//#include "sutils.h"
#include "Particle.h"
//#include "Matrix.h"


class Mat
{
public:
	Mat(int dim,int option1):n(dim),option(option1),p1(0),covar(n,n),v(n,n),d(n),xmean(n),y(n),wmat(n,n){ }
	void computeCovar(Particle* pBegin,Particle* pEnd);
	void computeICA(Particle* pBegin,Particle* pEnd);
	void rotatePCA_ICA(Particle *pFirst1,Particle *pLast1,Particle *pFirst2,Particle *pLast2);
	~Mat();
//	void jacobi(Matrix<double> &covar,Matrix<double> &v,std::vector<double> &d);
	void jacobi();
	inline void rot(Matrix<double> &a, const double s, const double tau, const int i,const int j, const int k, const int l)
	{
		double g = a[i][j];
		double h = a[k][l];
		a[i][j] = g - s * (h + g * tau);
		a[k][l] = h + s * (g - h * tau);
	}
private:
	int n,option,p1;
// ICA parameters
public:
	Matrix<double> covar;
	Matrix<double> v;
	std::vector<double> d;
	std::vector<double> xmean;
	std::vector<double> y;
	Matrix<double> wmat;
};



template <class type> void normalize(type first, type last)
{
	type cur;
	double temp=0.0;
	cur=first;
	while (cur!=last)
		temp+=(*cur)*(*cur++);
	temp=1.0/sqrt(temp);
	cur=first;
	while (cur!=last)
		(*cur++)*=temp;
}

void normalize1( );






#endif /* MAT_H_ */
