//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef NODE_H_
#define NODE_H_


//#include "sutils.h"
#include "Particle.h"
#include "Splitter.h"

class Node
{
public:
	Node();
	~Node();
	inline  int type(){return 0;};
	void print(Node* root,Particle* Pa);
//	void setUpRoot(Particle* pFirst1, Particle* pLast1,ParticleStats &pStat);
//	void split(ParticleStats &pStat);
	void setUpRoot(Particle* pFirst1, Particle* pLast1,Splitter &pStat,int maxNodes);
	void split(Splitter &pStat);
	inline void setChildren(Node* child) {left=child;};
	inline Node* rightN() {return (left+1);};
	inline Node* leftN() {return (left);};
	inline  int  count ( )  const {return (pLast-pFirst);};
	inline  double  get_xSplit ( )  const {return xSplit;};
	inline  int  get_kSplit ( )  const {return kSplit;};
	inline  double  xb (int i )  const {return x[i];};
	inline  double bound (int i) const  {return bnd[i];};
	void update_node_realloc(Node* rootP,Node* rootN)
	{
			if(left!=NULL)
				left=rootN+(left-rootP);
			if(parent!=NULL)
				parent=rootN+(parent-rootP);
	}
	void update_bnd_realloc(double* bndP,double* bndN)
	{
		if(bnd!=NULL)
			bnd=bndN+(bnd-bndP);
	}
private:
	int kSplit;
	double xSplit;
	double x[2];
	Node *left;
public:
	Node *parent;
	double* bnd;
	Particle* pFirst;
	Particle* pLast;
};

#endif /*NODE_H_*/
//	void setUpBoundary (ParticleStats &pStat);
//	void computeSplitParameters( int dim,ParticleStats &pStat);
//	void setUp(Particle* pFirst1, Particle* pLast1,Node* N,double*& bnd1,int dim);
