//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef PARAMETERS_H_
#define PARAMETERS_H_

#include "sutils.h"

class Parameters
{
#define ND 6
public:
	Parameters();
	~Parameters();
	void setFromArguments(int argc,char **argv);
	int setFromArguments_from_string(std::string command,std::string metric);
	void print( );
	void usage( );
	int checkCompilation( );
	//---General  options--------------------------------------------
	int Debug;
	int Dim;
//	int ICFormat;
	char InitCondFile[512],DeSuffix[512],GrSuffix[512],PaSuffix[512];
	std::string TargetFile,ImageFile;
	int MetricOn;
	int DensityOn;
	int NgblistOn;
	int ClusterOn;
	//----Density options  AM=adaptive metric Ker=Kernel Sp=Spherical Pr=Product
	int DesNumNgb;
	int DesNumNgbA;
	int TypeOfSmoothing;
	int DensityScatter;
	int VolCorrOn;
	int TypeOfKernel;
	int KernelBiasCorrectionOn;
	int BootstrapOn;
	int RotationOn;
	int NormalEuclideanMetricOn;
	double mu0;
	//----Tree related options-----------------------------------------
	double SpatialScale;
//	int PartBoundary;
	int NodeSplittingCriterion;
	int CubicCellsOn;
	int TreeType;
	int MedianSplittingOn;
	int AnisotropyOn;
	int PeriodicBoundaryOn;
	std::vector<double> p_length;
	std::vector<double> metric_default;
	//----Group Finder Parameters-------------------------------------
	int MinGpSize;
	double PeakHeight;
	double RhoB;
	double Delta;
	int SepCriteria;
	double ContactRatio;
	int GAnisotropyOn;
	int ErrorOption;
	int VoxelsOn;
	double sigma_mu;
	double sigma_vlb;
	double sigma_vr;
	double sigma_r;
	int massDensityOn;
	int asciiOn;
//	int Extra;
	#undef ND
};

#endif /*PARAMETERS_H_*/
// Unused parameters
	//	int flag_rotate;
	//	int MaxPart,TypeListOn;
	//	char SelectiveTypeListFile[100];
	/* Cosmology */
	//	double OmegaBaryon;
	//	double Omega0;
	//    double BoxSize, BoxHalf;
//	double MassTable[6];
	/* File options */
	/* Some other global parameters */
	//  double  Vd;
//	int flag_swap;
//	int order_flag;
//	int SurveyOption;
//	double SurveyArea;
//	double SurveyStripWidth;
//	double SurveyStripLength;
//	double SurveyMagnitudeMin;
//	double SurveyMagnitudeMax;
//	double AbsMagnitudeMin;
//	double AbsMagnitudeMax;
//	double SurveyTheta;
//	double SurveyPhi;
//	int SurveyErrorOn;

	//  Grid Density Options
	//    int pnew,SliceDepth;
//	int ImageOn,GridCenteringOn,GridPixels[3];
//	double GridCenter[6], GridSize,rmin,rmax;
//	int AutoScale;
	//	int ImOn;
	//	double* hs;
	//	double hsv;
