//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef PARTICLEPRIORITYQUEUE_H_
#define PARTICLEPRIORITYQUEUE_H_
#include"Particle.h"
//#include"Matrix.h"




class Neighbor
{
public:
	Particle* Pa;
	double r;
    inline bool operator<( const Neighbor &a ) const    {	return r < a.r;    }
    inline bool operator>( const Neighbor &a ) const    {	return r > a.r;    }
};

//template< int i >
//class LOOP{
//  public:
//    static inline void EXEC(){
//      cout << "A-" << i << " ";
//            LOOP< i-1 >::EXEC();
//       cout << "B-" << i << " ";
//    }
//};
//
//template<>
//class LOOP< 0 >{
//  public:
//    static inline void EXEC(){
//      cout << "A-" << i;
//      cout << "\n";
//       cout << "B-" << i;
//    }
//};


template<int nd>
class DistanceComputer
{
public:
	static inline void EXEC(double* Pos,double* xyz,double* metric,double &pqR,double &temp,double &r)
	{
	temp=((*Pos)-(*xyz))*(*metric);
	r+=temp*temp;
	if(r<pqR)
		DistanceComputer<nd-1>::EXEC(Pos+1,xyz+1,metric+1,pqR,temp,r);
	}
};

//template<>
//class DistanceComputer<  0 >
//{
//public:
//	static inline void EXEC(double* Pos,double* xyz,double* metric,double &pqR,double &temp,double &r)
//	{
//
//	}
//};

//template<int nd>
//class BoxResizer
//{
//public:
//	static inline void EXEC(double** searchx,double* searchCenter,double* metric,double &temp,double &temp1)
//	{
//		temp1=temp/metric[0];
//		searchx[0][0]=searchCenter[0]-temp1;
//    	searchx[0][1]=searchCenter[0]+temp1;
//		BoxResizer<nd-1>::EXEC(searchx+1,searchCenter+1,metric+1,temp,temp1);
//	}
//};

//template<>
//class BoxResizer<0>
//{
//public:
//	static inline void EXEC(double** searchx,double* searchCenter,double* metric,double &temp,double &temp1)
//	{
//	}
//};



class ParticlePriorityQueue
{
public:
	ParticlePriorityQueue();
	~ParticlePriorityQueue();
	void initialize(Particle* pBegin1,Particle* pEnd1,int ngbsize1,int dim1);
	inline Neighbor& operator[] (unsigned i) const {return ngblist[i];};
	inline Neighbor& top() const {return ngblist[0];};
	inline Neighbor* begin() const {return &ngblist[0];};
	inline Neighbor* end() const {return &ngblist[csize];};
	inline  int  size ( )  const {return csize;};
	void reset(const double* searchcenter,const double* metric);
	void reset2(const double* searchcenter,const double* metric);
	void push1(Particle* Pa1);
	void push1(Particle* Pa1,double* lp);
	void push2(Particle* Pa1);
	void print();
	double density();
	double hinvd;
	double* searchCenter;
	double* metric;
	double** searchx;
	void ngbList(int parent,std::vector<int>  &ngbList,std::vector<double> &rList,int items);
	Particle* pNext();
	void setImarkB(bool *imark);
	void clearImarkB();
//	template<int nd>
//	inline void push(Particle* Pa1)
//	{
////	int j;
//		if(imarkA[(Pa1-pFirst)]==0)
//		{
//	//			for(j=0; j<dim; ++j)
//	//			    {
//	//					if((Pa1->Pos[j])>searchx[j][1])
//	//			    		break;
//	//			    	if((Pa1->Pos[j])<searchx[j][0])
//	//			    		break;
//	//			    }
//	//		    if(j==dim)
////		    {
////		    	double temp=Pa1->distance_pq(searchCenter,metric,dim,ngblist[0].r);
//		    	double temp=0,temp1=0;
//		    	    DistanceComputer<nd>::EXEC(Pa1->Pos,searchCenter,metric,ngblist[0].r,temp1,temp);
//
//		    		if(temp<ngblist[0].r)
//		    	{
//		    		imarkA[(ngblist[0].Pa-pFirst)]=0;
//		    		ngblist[0].Pa=Pa1;
//		    		ngblist[0].r=temp;
//		    		imarkA[(Pa1-pFirst)]=1;
//
//		    		adjust_heap();
//
//		    		temp=sqrt(top().r);
////		    	    for(int k=0; k<dim; ++k)
////		    	    {
////		    	    	searchx[k][0]=searchCenter[k]-temp/metric[k];
////		    	    	searchx[k][1]=searchCenter[k]+temp/metric[k];
////		    	    }
//		    		BoxResizer<nd>::EXEC(searchx,searchCenter,metric,temp,temp1);
////		    		temp1=temp/metric[0];
////		    		searchx[0][0]=searchCenter[0]-temp1;
////	    	    	searchx[0][1]=searchCenter[0]+temp1;
////		    		temp1=temp/metric[1];
////	    	    	searchx[1][0]=searchCenter[1]-temp1;
////	    	    	searchx[1][1]=searchCenter[1]+temp1;
////		    		temp1=temp/metric[2];
////	    	    	searchx[2][0]=searchCenter[2]-temp1;
////	    	    	searchx[2][1]=searchCenter[2]+temp1;
//
//
//		    	}
////		    }
//
//		}
//	}
//	template<int nd>
//	inline void pushAll(Particle* Pa1,Particle*Pa2)
//	{
//		int j=0;
//    	double temp=0,temp1=0;
//		for (Particle* Part=Pa1; Part<Pa2; Part++)
//		if(imarkA[(Part-pFirst)]==0)
//		{
//		    	temp=0,temp1=0;
//		    	    DistanceComputer<nd>::EXEC(Part->Pos,searchCenter,metric,ngblist[0].r,temp1,temp);
//
//		    		if(temp<ngblist[0].r)
//		    	{
//		    		imarkA[(ngblist[0].Pa-pFirst)]=0;
//		    		ngblist[0].Pa=Part;
//		    		ngblist[0].r=temp;
//		    		imarkA[(Part-pFirst)]=1;
//
//		    		adjust_heap();
//		    		j=1;
//		    	}
//		}
//		if(j!=0)
//		{
//			temp=sqrt(top().r);
//			BoxResizer<nd>::EXEC(searchx,searchCenter,metric,temp,temp1);
//		}
//	}
	Neighbor* ngblist;
private:
	int maxSize;
	int csize;
	int dim;
	bool* imarkA;
	bool* imarkB;
	Particle* pFirst;
	int hi,hj;
	Neighbor ngbTemp;
	Matrix<double> gmatrix;
	inline void  adjust_heap( )
	{
		hi=0;
		while(1)
		{
			hj=((hi+1)<<1);
			if(hj>csize)
				break;
			--hj;
			if(hj<(csize-1))
				if(ngblist[hj]<ngblist[hj+1])
					++hj;
			if(ngblist[hi]<ngblist[hj])
			{
				ngbTemp=ngblist[hj];
				ngblist[hj]=ngblist[hi];
				ngblist[hi]=ngbTemp;
				hi=hj;
			}
			else
			break;
		}
	}
};

#endif /*PARTICLEPRIORITYQUEUE_H_*/
