//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================

#ifndef SURVEYERROR_H_
#define SURVEYERROR_H_
#include "Functions.h"
#include "Matrix.h"


class StarParticle
{
public:
	double Pos[10];
    inline double& feh() {return Pos[6];}
    inline double& alpha() {return Pos[7];}
    inline double& mag(int k) {return Pos[8+k];}
    void initialize( )
    {
    	for(int j=0;j<10;++j)
    		Pos[j]=0;
    }
    template<class T>
    void read(T Pos)
    {
//    	for(int i=0;i<12;++i)
//    		Starf.Pos[i]=float(Pos[i]);
//    	Starf.satID()=int(satID());
    }
    template<class T>
    void write(T Pos)
    {
//    	for(int i=0;i<12;++i)
//    		Starf.Pos[i]=float(Pos[i]);
//    	Starf.satID()=int(satID());
    }
};




class SurveyError
{
private:
	double sigma_w,sigma_mu,sigma_r,sigma_vr,sigma_vlb,sigma_fe,sigma_al;
	void initialize();
public:
	SurveyError(int errorOption1,double sigma_mu1,double sigma_vlb1,double sigma_vr1,double sigma_r1):sigma_mu(sigma_mu1),sigma_r(sigma_r1),sigma_vr(sigma_vr1),sigma_vlb(sigma_vlb1),errorOption(errorOption1),gauss(0.0,1.0,23l),randomu(3l){initialize();}
	Matrix<double> TM;
	std::vector<double> appMag;
	std::vector<double> vr;
	int errorOption;
	Normaldev gauss;
	Ran randomu;
//	void lbr_to_xyz(double *PosS,double *PosC);
//	void xyz_to_lbr(double *PosC,double *PosS);
	void xyz_to_lbr(double *PosC,double *PosS,int dim);
	void lbr_to_xyz(double *PosS,double *PosC,int dim);
	void lbr_to_hammer_aitoff(double* Pos);
	void xyz_to_hammer_aitoff(double* Pos);
	void add(StarParticle &Star);
	~SurveyError();
};






#endif /* SURVEYERROR_H_ */
