//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef GFEXTRA_H_
#define GFEXTRA_H_
//#include "sutils.h"
//#include "Parameters.h"
#include "gf.h"


double rtbis(double ( *func)(double ),const double x0, const double x1, const double x2);
float calculate_sigma(int d);
void load_table_fm(std::vector<float> &tb_fm,std::vector<float> &tb_cr);
void sort_plist(const char *filename);
void load_Par(const char *buf, std::vector<GParticle> &Par, int &NumPart,std::vector<int> &nx,std::vector<int> &sortedList);
void load_plist1(const char *filename,std::vector<class Plist> &plv,std::vector<GParticle> &Par, int &nmerge,int &NumPart, int &nc,FILE* &fd);
void write_plist(const char *buf, std::vector<class Plist*> &pl,
		std::vector<class Plist> &plv, std::vector<class GParticle> &Par);
void load_plist(const char *buf, std::vector<class Plist*> &pl,
		std::vector<class Plist> &plv, std::vector<class GParticle> &Par);

class ParametersGF
{
public:
    //--Constant paramters
	int dim;
	int dim1;
	int SepCriteria;
	int ContactRatio;
	int DesNumNgb;
	int GAnisotropyOn;
	int Debug;
	int MinGpSize;
	int VoxelsOn;
	int massDensityOn;
	int64_t ntot;
	double PeakHeight;
	double sigma_rho;
	double Delta,RhoB;
	char InitCondFile[512],DeSuffix[512],GrSuffix[512];
    std::vector<float> tb_fm;
    std::vector<float> tb_cr;
    std::vector<int> nx;
    std::vector<int> x;
    //--Changing paramters
    int active_groups,group_id;
	void initialize(Parameters &All)
	{
		active_groups = 0;
		group_id = 0;
		dim=All.Dim;
		SepCriteria=All.SepCriteria;
		ContactRatio=All.ContactRatio;
		DesNumNgb=All.DesNumNgb;
		PeakHeight=All.PeakHeight;
		GAnisotropyOn=All.GAnisotropyOn;
		VoxelsOn=All.VoxelsOn;
		Debug=1;
		MinGpSize=All.MinGpSize;
		dim1=dim;
		if(All.NormalEuclideanMetricOn==3)
			dim1=dim1-1;
		assert(dim1>0);
		sigma_rho=calculate_sigma(dim1)/sqrt(DesNumNgb*1.0);
	    Delta=All.Delta;
	    RhoB=All.RhoB;
	    if(Delta>0.0)
	    	RhoB=0.0;
	    strcpy(InitCondFile,All.InitCondFile);
	    strcpy(DeSuffix,All.DeSuffix);
	    strcpy(GrSuffix,All.GrSuffix);
		load_table_fm(tb_fm,tb_cr);
		if((VoxelsOn==1)&&(dim!=3))
		{
			std::cout<<"dim must be 3"<<std::endl;
			exit(1);
		}
		massDensityOn=All.massDensityOn;
	}
	void setPeakHeight(int n)
	{
		if(PeakHeight < 0)
		{
//			double temp=0.5*pow(dim1,2.1)*pow(DesNumNgb*1.0,1.2)/(15.5*n);
//			PeakHeight=rtbis(erfc,temp,0.0,20)*sqrt(2);
			double temp=(-PeakHeight)*DesNumNgb/(0.4*n);
			PeakHeight=rtbis(erfc,temp,0.0,20)*sqrt(2)/sqrt((1-2.3/DesNumNgb)*(dim1/4.0));
//			double temp=(-PeakHeight)*DesNumNgb/(0.4*n);
//			PeakHeight=rtbis(erfc,temp,0.0,20)*sqrt(2)/0.9304;

			std::cout<<std::setprecision(3)<<"Peak Height computed as "<<PeakHeight<<" for n="<<n<<" d="<<dim1<<std::endl;
//			temp=0.5*pow(dim1,2.1)*pow(DesNumNgb*1.0,1.2)/(15.5*n);
//			std::cout<<std::setprecision(3)<<"Peak Height computed as "<<rtbis(erfc,temp,0.0,20)*sqrt(2)<<" for n="<<n<<" d="<<dim1<<std::endl;
		}
	}

};

struct io_header_1
{
    int npart[6];
    double   mass[6];
    double   time;
    double   redshift;
    int flag_sfr;
    int flag_feedback;
    int npartTotal[6];
    int flag_cooling;
    int num_files;
    double   BoxSize;
    double   Omega0;
    double   OmegaLambda;
    double   HubbleParam;
    /* extra flags other than gadget*/
    int flag_id;          /* if IDs needed in output */
    int flag_dim;         /* no of dimensions */
    /* signifies that output file contains estimated density */
    int flag_density;
    int flag_extra;
    char     fill[256- 6*4- 6*8- 2*8- 2*4- 6*4- 2*4 - 4*8-4*4];  /* fills to 256 Bytes */
};



#endif /* GFEXTRA_H_ */
