//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================

#include "Functions.h"


float gammln(float xx)
{
    double x,y,tmp,ser;
    static double cof[6]={76.18009172947146,-86.50532032941677,
			  24.01409824083091,-1.231739572450155,
			  0.1208650973866179e-2,-0.5395239384953e-5};
    int j;

    y=x=xx;
    tmp=x+5.5;
    tmp -= (x+0.5)*log(tmp);
    ser=1.000000000190015;
    for (j=0;j<=5;j++) ser += cof[j]/++y;
    return -tmp+log(2.5066282746310005*ser/x);
}

double volume_d(int dim)
{
	return 2.0*pow(3.14159,dim/2.0)/(dim*exp(gammln(dim/2.0)));
}

float interpolate(float r,std::vector<float> &tablex,std::vector<float> &tabley)
{
    float u;
    int i;
    u=(r-tablex[0])/(tablex[1]-tablex[0]);
    i=int(u);
    u=u-i;
//    cout<<i<<" a "<<u<<endl;
    if(i>=int(tabley.size()-1))
	return tabley[int(tabley.size()-1)];

    if(i<0)
	return tabley[0];
    else
	return tabley[i]*(1-u)+tabley[i+1]*u;

}


