/*
 * Image.cpp
 *
 *  Created on: 11/12/2012
 *      Author: sharma
 */

#include "Image.h"


Image::~Image()
{
	// TODO Auto-generated destructor stub
}

void Image::updateR(double* Pos,double* matrixa,double factor)
{
	double temp,fac;
	double PosB[6];
	int i=0;
	for(int j=0;j<dim;++j)
		for(int k=j;k<dim;++k)
		{
			mt.covar[j][k]=matrixa[i++];
			if(k!=j)
				mt.covar[k][j]=mt.covar[j][k];
		}
	mt.jacobi();
	mt.v.transpose();
	hl=0.0;

	for(int j=0;j<dim;++j)
	{
		mt.d[j]=factor*sqrt(mt.d[j]);
		if (hl<mt.d[j])
			hl=mt.d[j];
	}

	fac=fep;
	for(int k=0;k<dim;++k)
	{
		ixmin[k]=int((Pos[k]-hl-xmin[k])/dx);
		ixmax[k]=int((Pos[k]+hl-xmin[k])/dx);
		ixmin[k]=std::max(ixmin[k],0);
		ixmin[k]=std::min(ixmin[k],w-1);
		ixmax[k]=std::max(ixmax[k],0);
		ixmax[k]=std::min(ixmax[k],w-1);
		fac/=mt.d[k];
	}
	if (dim==2)
	{
		for(int i=ixmin[0];i<=ixmax[0];i++)
			for(int j=ixmin[1];j<=ixmax[1];j++)
			{
					PosB[0]=xmin[0]+i*dx;
					PosB[1]=xmin[1]+j*dx;
					r=0.0;
			    	for(int l1=0;l1<dim;++l1)
			    	{
			    		if(r>1)
			    			break;
		    			temp=(Pos[0]-PosB[0])*mt.v[l1][0];
			    		for(int l2=1;l2<dim;++l2)
			    			temp+=(Pos[l2]-PosB[l2])*mt.v[l1][l2];
			    		temp=temp/mt.d[l1];
			    		r+=temp*temp;
			    	}
				if(r<1.0)
				{
					im[i*w+j]+=fac*(1-r);
				}
			}
	}
	else if (dim==3)
	{
		for(int i=ixmin[0];i<=ixmax[0];i++)
			for(int j=ixmin[1];j<=ixmax[1];j++)
				for(int k=ixmin[2];k<=ixmax[2];k++)
			{
					PosB[0]=xmin[0]+i*dx;
					PosB[1]=xmin[1]+j*dx;
					PosB[2]=xmin[2]+k*dx;
					r=0.0;
			    	for(int l1=0;l1<dim;++l1)
			    	{
			    		if(r>1)
			    			break;
		    			temp=(Pos[0]-PosB[0])*mt.v[l1][0];
			    		for(int l2=1;l2<dim;++l2)
			    			temp+=(Pos[l2]-PosB[l2])*mt.v[l1][l2];
			    		temp=temp/mt.d[l1];
			    		r+=temp*temp;
			    	}
				if(r<1.0)
				{
					im[i*w*w+j*w+k]+=fac*(1-r);
				}
			}
	}
}
void Image::update(double* Pos,double* metric,double factor)
{
	double temp,fac;
	double PosB[6];
	hl=0.0;
	for(int j=0;j<dim;++j)
	{
		mt.d[j]=factor/metric[j];
		if (hl<mt.d[j])
			hl=mt.d[j];
	}

	fac=fep;
	for(int k=0;k<dim;++k)
	{
		ixmin[k]=int((Pos[k]-hl-xmin[k])/dx);
		ixmax[k]=int((Pos[k]+hl-xmin[k])/dx);
		ixmin[k]=std::max(ixmin[k],0);
		ixmin[k]=std::min(ixmin[k],w-1);
		ixmax[k]=std::max(ixmax[k],0);
		ixmax[k]=std::min(ixmax[k],w-1);
		fac/=mt.d[k];
	}
	if (dim==2)
	{
		for(int i=ixmin[0];i<=ixmax[0];i++)
			for(int j=ixmin[1];j<=ixmax[1];j++)
			{
					PosB[0]=xmin[0]+i*dx;
					PosB[1]=xmin[1]+j*dx;
					r=0.0;
			    	for(int l1=0;l1<dim;++l1)
			    	{
			    		if(r>1)
			    			break;
			    		temp=(Pos[l1]-PosB[l1])/mt.d[l1];
			    		r+=temp*temp;
			    	}
				if(r<1.0)
				{
					im[i*w+j]+=fac*(1-r);
				}
			}
	}
	else if (dim==3)
	{
		for(int i=ixmin[0];i<=ixmax[0];i++)
			for(int j=ixmin[1];j<=ixmax[1];j++)
				for(int k=ixmin[2];k<=ixmax[2];k++)
			{
					PosB[0]=xmin[0]+i*dx;
					PosB[1]=xmin[1]+j*dx;
					PosB[2]=xmin[2]+k*dx;
					PosB[0]=xmin[0]+i*dx;
					PosB[1]=xmin[1]+j*dx;
					r=0.0;
			    	for(int l1=0;l1<dim;++l1)
			    	{
			    		if(r>1)
			    			break;
			    		temp=(Pos[l1]-PosB[l1])/mt.d[l1];
			    		r+=temp*temp;
			    	}
				if(r<1.0)
				{
					im[i*w*w+j*w+k]+=fac*(1-r);
				}
			}
	}

}


void Image::write(const std::string& outfile)
{

	if (dim==1)
		ebf::Write(outfile,"/data",&im[0],"w","",w);
	else if (dim==2)
		ebf::Write(outfile,"/data",&im[0],"w","",w,w);
	else if (dim==3)
		ebf::Write(outfile,"/data",&im[0],"w","",w,w,w);

}
void Image::writeascii(const std::string& outfile)
{
	std::cout<<"Writing Ascii image file"<<std::endl;
	std::ofstream fout(outfile.c_str());
	if (dim==1)
		fout<<"# "<<w<<std::endl;
	else if (dim==2)
		fout<<"# "<<w<<" "<<w<<std::endl;
	else if (dim==3)
		fout<<"# "<<w<<" "<<w<<" "<<w<<std::endl;

	fout.setf(std::ios::scientific);
	fout<<std::setprecision(6);
	for(size_t i=0;i<im.size();++i)
	{
		fout<<im[i]<<std::endl;
	}
	double mtot=0.0;
	for(size_t i=0;i<=im.size();i++)
			mtot+=im[i]*dx*dx;
	std::cout<<" mtot="<<mtot<<" "<<dx<<std::endl;


}


