//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================

#include<numeric>
#include "Mat.h"

Mat::~Mat()
{
//	delete [] data;
//	if(data1!=NULL) delete [] data1;
//	if(data2!=NULL) delete [] data2;
//	 TODO Auto-generated destructor stub
}

//Mat::Mat(int columns1,int rows1)
//{
//	columns=columns1;
//	rows=rows1;
//	data=new double[columns*rows];
//	data1=NULL;
//	data2=NULL;
//	// TODO Auto-generated constructor stub
//}
//vector<int> operator+(int i,vector<int> a)
//{
//	for(int j=0;j<a.size();j++)
//	{
//		a[j]+=i;
//	}
//}
//
void Mat::rotatePCA_ICA(Particle *pFirst1,Particle *pLast1,Particle *pFirst2,Particle *pLast2)
{
	computeCovar(pFirst1,pLast1);
	jacobi();
	for (int j=0; j<n; j++)
		d[j]=sqrt(d[j]);
	v.transpose();
	for (int j=0; j<n; j++)
		for (int k=0; k<n; k++)
			v[j][k]/=d[j];

	for (Particle* Pa=pFirst2; Pa<pLast2; ++Pa)
	{
		for (int j=0; j<n; j++)
			y[j]=Pa->Pos[j]-xmean[j];
		v.mult(&y[0],Pa->Pos);
	}

//	if((pLast1-pFirst1)>128)
	{
	computeICA(pFirst1,pLast1);
	for (Particle* Pa=pFirst2; Pa<pLast2; ++Pa)
	{
		for (int j=0; j<n; j++)
			y[j]=Pa->Pos[j];
		wmat.mult(&y[0],Pa->Pos);
	}
	}
}

void Mat::computeCovar(Particle *pFirst,Particle *pLast)
{
	int j,k;
	double temp;
//	vector<double> xmean(n,0.0);
	for(j=0;j<n;++j)
		xmean[j]=0.0;
	for(j=0;j<n;++j)
		for(k=0;k<n;++k)
			covar[j][k]=0.0;

	for (Particle* Pa=pFirst; Pa<pLast; ++Pa)
	{
		for(j=0;j<n;++j)
		{
			temp=Pa->Pos[j];
			xmean[j]+=temp;
			for(k=j;k<n;++k)
			{
				covar[j][k]+=temp*(Pa->Pos[k]);
			}
		}
	}

	temp=1.0/(pLast-pFirst);
	for(j=0;j<n;++j)
		xmean[j]*=temp;

	for(j=0;j<n;++j)
		for(k=j;k<n;++k)
		{
			covar[j][k]*=temp;
			covar[j][k]-=xmean[j]*xmean[k];
			if(j!=k)
				covar[k][j]=covar[j][k];
		}
//	jacobi();
//		jacobi(covar,v,d);
}



void eigsrt(std::vector<double> &d, Matrix<double> *v = NULL)
{
	int k;
	int n = d.size();
	for (int i = 0; i < n - 1; i++)
	{
		double p = d[k = i];
		for (int j = i; j < n; j++)
			if (d[j] >= p)
				p = d[k = j];

		if (k != i)
		{
			d[k] = d[i];
			d[i] = p;
			if (v != NULL)
				for (int j = 0; j < n; j++)
				{
					p = (*v)[j][i];
					(*v)[j][i] = (*v)[j][k];
					(*v)[j][k] = p;
				}
		}
	}
}



//void Mat::jacobi(Matrix<double> &covar,Matrix<double> &v,std::vector<double> &d)
void Mat::jacobi( )
{
	Matrix<double> a(covar);
	int nrot=0;
	double EPS=std::numeric_limits<double>::epsilon();
	int i, j, ip, iq;
	double tresh, theta, tau, t, sm, s, h, g, c;
	std::vector<double> b(n), z(n);
	for (ip = 0; ip < n; ip++)
	{
		for (iq = 0; iq < n; iq++)
			v[ip][iq] = 0.0;
		v[ip][ip] = 1.0;
	}

	for (ip = 0; ip < n; ip++)
	{
		b[ip] = d[ip] = a[ip][ip];
		z[ip] = 0.0;
	}

	for (i = 1; i <= 50; i++)
	{
		sm = 0.0;
		for (ip = 0; ip < n - 1; ip++)
		{
			for (iq = ip + 1; iq < n; iq++)
				sm += fabs(a[ip][iq]);
		}
		if (sm == 0.0)
		{
//			eigsrt1();
//			eigsrt(d, &v);
			return;
		}
		if (i < 4)
			tresh = 0.2 * sm / (n * n);
		else
			tresh = 0.0;

		for (ip = 0; ip < n - 1; ip++)
		{
			for (iq = ip + 1; iq < n; iq++)
			{
				g = 100.0 * fabs(a[ip][iq]);
				if (i > 4 && g <= EPS * fabs(d[ip]) && g <= EPS * fabs(d[iq]))
					a[ip][iq] = 0.0;
				else if (fabs(a[ip][iq]) > tresh)
				{
					h = d[iq] - d[ip];
					if (g <= EPS * fabs(h))
						t = (a[ip][iq]) / h;
					else
					{
						theta = 0.5 * h / (a[ip][iq]);
						t = 1.0 / (fabs(theta) + sqrt(1.0 + theta * theta));
						if (theta < 0.0)
							t = -t;
					}
					c = 1.0 / sqrt(1 + t * t);
					s = t * c;
					tau = s / (1.0 + c);
					h = t * a[ip][iq];
					z[ip] -= h;
					z[iq] += h;
					d[ip] -= h;
					d[iq] += h;
					a[ip][iq] = 0.0;
					for (j = 0; j < ip; j++)
						rot(a, s, tau, j, ip, j, iq);

					for (j = ip + 1; j < iq; j++)
						rot(a, s, tau, ip, j, j, iq);

					for (j = iq + 1; j < n; j++)
						rot(a, s, tau, ip, j, iq, j);

					for (j = 0; j < n; j++)
						rot(v, s, tau, j, ip, j, iq);
					++nrot;
				}
			}
		}

		for (ip = 0; ip < n; ip++)
		{
			b[ip] += z[ip];
			d[ip] = b[ip];
			z[ip] = 0.0;
		}
	}
	std::cout<<"Too many iterations in routine jacobi"<<std::endl;
}




void Mat::computeICA(Particle *pBegin, Particle *pEnd)
{
	double temp, temp1, g, g1, u, beta, tol, err, mu;
	int ii, j, k, p, iter=80,NumPart1;
	std::vector<double> w0(n,0.0), w1(n,0.0), w2(n,0.0), w3(n,0.0), x_g(n,0.0);
	mu=1.0;
	tol=1e-6;
	//	if(NumPart>1000)
	//	{mu=0.1;tol=1e-6;iter=1000;}
	Particle *Pa=pBegin;
	NumPart1=pEnd-pBegin;
//	int p1=0;
	for (p=p1; p<n; p++)
	{

		for (k=0; k<n; k++)
		{
			x_g[k]=0.0;
			w0[k]=drand48();
		}
		normalize(w0.begin(), w0.end());

		for (ii=0; ii<iter; ii++)
		{
			for (k=0; k<n; k++)
				x_g[k]=0.0;
			beta=0.0;
			g1=0.0;

			for (j=0; j<NumPart1; j++)
			{
				u=inner_product(w0.begin(), w0.end(), Pa[j].Pos, 0.0);
				//						g=u*exp(-u*u/2.0);
				if (option)
					g=u*exp(-u*u/2.0);
				else
					//	g=tanh(0.1*u);
					g=u*u*u;
				for (k=0; k<n; k++)
					x_g[k]+=Pa[j].Pos[k]*g;

				if (option)
					g1+=g/u+u*g;
				else
					g1+=3*u*u;
				//	g1+=(1-g*g);
				beta+=u*g;
			}

			beta/=NumPart1;
			g1/=NumPart1;
			for (k=0; k<n; k++)
				x_g[k]/=NumPart1;

			for (k=0; k<n; k++)
				w1[k]=w0[k]-mu*(x_g[k]-beta*w0[k])/(g1-beta);

			normalize(w1.begin(), w1.end());

			//    	gs_orthogonalize(w1.begin(),w1.end(),wmat,p)
			for (k=0; k<n; k++)
				x_g[k]=w1[k];
			for (j=0; j<p; j++)
			{
				for (k=0; k<n; k++)
					w2[k]=wmat[j][k];
				u=inner_product(x_g.begin(), x_g.end(), w2.begin(), 0.0);
				for (k=0; k<n; k++)
					w1[k]-=u*wmat[j][k];

			}
			normalize(w1.begin(), w1.end());

			//    	for(k=0;k<n;k++)
			//    		cout<<w0[k]<<" ";
			//		cout<<endl;
			//    	for(k=0;k<n;k++)
			//    		cout<<w1[k]<<" ";
			//		cout<<endl;
			//		cout<<endl;

			for (k=0, err=0.0; k<n; k++)
				err+=fabs(w1[k]-w0[k]);
			if (err < tol)
				break;
			for (k=0; k<n; k++)
				w0[k]=w1[k];
			//
			//			cout<<scientific<<"p iter error "<<p<<" "<<ii<<" "<<err<<" "<<NumPart<<endl;
			//			if((iter%40==0)&&(err>tol*10))
			//			{
			//				for (k=0; k<n; k++)
			//					w0[k]=drand48();
			//				normalize(w0.begin(), w0.end());
			//			}
		}
		//		cout<<scientific<<"p iter error "<<p<<" "<<ii<<" "<<err<<" "<<NumPart<<endl;
		p1++;
		if (ii==iter)
		{
			p1--;
			if (p==0)
			{
//				ica_status=0;
				for (j=0; j<n; j++)
					for (k=0; k<n; k++)
					{
						if (j==k)
							wmat[j][k]=1.0;
						else
							wmat[j][k]=0.0;
					}
				p=n;
			}
			while (p<n)
			{
				temp1=0.0;
				for (int l=0; l<n; l++)
				{
					for (k=0; k<n; k++)
						x_g[k]=0.0;
					x_g[l]=1.0;
					for (k=0; k<n; k++)
						w3[k]=x_g[k];
					for (j=0; j<p; j++)
					{
						for (k=0; k<n; k++)
							w2[k]=wmat[j][k];
						u=inner_product(x_g.begin(), x_g.end(),w2.begin(), 0.0);
						for (k=0; k<n; k++)
							w3[k]-=u*wmat[j][k];
					}
					for (k=0, temp=0.0; k<n; k++)
						temp+=w3[k]*w3[k];
					if (temp > temp1)
					{
						temp1=temp;
						for (k=0; k<n; k++)
							w1[k]=w3[k];
					}
				}
				//				for (k=0; k<n; k++)
				//					cout<<w1[k]<<" ";
				//				cout<<endl;

				normalize(w1.begin(), w1.end());
				for (k=0; k<n; k++)
					wmat[p][k]=w1[k];
				p++;
			}
		}
		else
		{
			for (k=0; k<n; k++)
				wmat[p][k]=w1[k];
		}
		//        exit(1);

	}
	//	cout<<"w"<<endl;
	//	for (k=0; k<n; k++)
	//	{
	//		for (j=0; j<n; j++)
	//			cout<<wmat[j][k]<<" ";
	//		cout<<endl;
	//	}
	//	        exit(1);
//	for (k=0; k<n; k++)
//		for (p=0; p<n; p++)
//			scale.rmatrix[k*n+p]=wmat[p][k];
//	return p1;
}

