//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#include "Timer.h"
#include "ebf.hpp"



Timer::Timer()
{
	start();
}

Timer::~Timer()
{
}

void Timer::start()
{
	startTime=clock();
	stopTime=clock();
}

void Timer::stop()
{
	stopTime=clock();
}


void Timer::resume()
{
	startTime=clock()-(stopTime-startTime);
	stopTime=clock();
}


double Timer::elapsedTime()
{
	return double(stopTime-startTime)/CLOCKS_PER_SEC;
}

double Timer::currentTime()
{
	return double(clock()-startTime)/CLOCKS_PER_SEC;
}


void Timer::print()
{
	stop();
	std::cout<<std::left<<std::setw(12)<<" Time "<<std::setw(12)<<elapsedTime()<<std::endl;
}
void Timer::print(const char *s)
{
	stop();
	std::cout<<std::left<<std::setw(36)<<s<<std::setw(12)<<elapsedTime()<<std::endl;
}
void Timer::print(const char *s,double n)
{
	stop();
	std::cout<<std::left<<std::setw(36)<<s<<std::setw(12)<<elapsedTime()<<"     (  "<<n*1e-6/elapsedTime()<<" Mops )"<<std::endl;
}

void Timer::printC()
{
	std::cout<<std::left<<std::setw(12)<<" Time "<<std::setw(12)<<currentTime()<<std::endl;
}
void Timer::printC(const char *s)
{
	std::cout<<std::left<<std::setw(36)<<s<<std::setw(12)<<currentTime()<<std::endl;
}
void Timer::printC(const char *s,double n)
{
	std::cout<<std::left<<std::setw(36)<<s<<std::setw(12)<<currentTime()<<"     (  "<<n*1e-6/currentTime()<<" Mops )"<<std::endl;
}


void getTypeCheck()
{
	char x1=0;
	int x2=0;
	int64_t x3=0;
	float x4=0;
	double x5=0;
	int status=0;

	if((ebf::TypeV(x1)==1)&&(ebf::TypeV(x2)==2)&&(ebf::TypeV(x3)==3)&&(ebf::TypeV(x4)==4)&&(ebf::TypeV(x5)==5))
		status=1;
	if(status==0)
	{
		std::cout<<"function TypeV not working properly"<<std::endl;
		exit(1);
	}
}
