//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#include <algorithm>
#include "Tree.h"
#include "Timer.h"
#include "Kernel.h"


void printMetric1(std::vector<float> &pMetric,int count,int dim)
{

std::vector<double> metric1(dim,0.0);
std::vector<double> metric2(dim,0.0);
std::vector<double> metric3(dim,0.0);
std::vector<double> metric4(dim,0.0);
float temp;
for(int k=0;k<dim;++k)
{
	temp=pMetric[k];
//	temp=1.0/sqrt(pMetric[k]);
		metric1[k]=temp;
		metric2[k]=temp;
		metric3[k]+=temp;
		metric4[k]+=temp*temp;
}
for(int i=1;i<(count);++i)
	{
		for(int k=0;k<dim;++k)
		{
			temp=pMetric[i*dim+k];
//			temp=1.0/sqrt(pMetric[i*dim+k]);
			if(metric1[k]>temp)
				metric1[k]=temp;
			if(metric2[k]<temp)
				metric2[k]=temp;
			metric3[k]+=temp;
			metric4[k]+=temp*temp;
		}
	}
for(int k=0;k<dim;++k)
{
	metric3[k]/=count;
	metric4[k]/=count;
	metric4[k]=sqrt(metric4[k]-metric3[k]*metric3[k]);
}
std::cout<<"-----------------------------------------------------------------------------"<<std::endl;
std::cout<<"Printing metric stats"<<std::endl;
std::cout<<std::setw(16)<<"Data count N="<<count<<std::endl;
	std::cout<<std::scientific<<std::setprecision(6)<<std::setw(16)<<"d or d(d+1)/2"<<std::setw(16)<<"Min"<<std::setw(16)<<"Max"<<std::setw(16)<<"Mean"<<std::setw(12)<<"Sig"<<std::endl;
	std::cout<<"-----------------------------------------------------------------------------"<<std::endl;
	for(int k=0;k<dim;++k)
		std::cout<<std::setw(16)<<k<<std::setw(16)<<metric1[k]<<std::setw(16)<<metric2[k]<<std::setw(16)<<metric3[k]<<std::setw(16)<<metric4[k]<<std::endl;
	std::cout<<"-----------------------------------------------------------------------------"<<std::endl;

//	std::cout<<"Metric Stats "<<metric3[2]/sqrt(metric3[0]*metric3[1])<<" "<<metric3[2]*sqrt(8)/sqrt(metric3[0]*metric3[1])<<std::endl;

}


void calculate_metric(const char* fname,Particle* pFirst2, Particle* pLast2,int leafSize,int treeType,int rotationOn,int dim,int items)
{

	 int tnum=1;
//	 #pragma omp parallel
//	 {
//		 tnum=omp_get_num_threads();
//	 }

	Timer t1;
	t1.start();
	ParticleStats1 pStat(dim);
	NodeA* root;
	Ran randomu(17l);
	int	count=pLast2-pFirst2;
	int iter_tot=20;
//	std::vector<float>  pMetric(count*pStat.dim,0.0);

	std::vector<int> info(10,0);
	info[0]=2;	info[1]=count;
	if(rotationOn==1)
		info[2]=(dim*(dim+1))/2;
	else
		info[2]=dim;
	info[3]=4;  info[4]=info[1]*info[2];  info[5]=sizeof(float);

	std::vector<Particle> Pa2(count);
	double sizefactor=0.1;

	if((sizefactor)<(pow(2.0,dim)*10.0/count))
		sizefactor=pow(2.0,dim)*10.0/count;

//	if(sizefactor>0.67)
//			leafSize=count+1;
	sizefactor=std::min(sizefactor,1.0);
	std::cout<<"sizefactor="<<sizefactor<<" count="<<count<<" leafSize="<<leafSize<<std::endl;


	for(int j=0;j<iter_tot;++j)
	{
		for(int i=0;i<count;++i)
			Pa2[i]=pFirst2[i];

		// old random list
//		std::vector<int> listr(count,0);
//		for(int i=0;i<count;++i)
//		    listr[i]=randomu.int32()%count;
//		sort(listr.begin(),listr.end());
//		std::vector<int>::iterator iter=unique(listr.begin(),listr.end());
//		listr.resize(iter-listr.begin());
//		std::vector<Particle> Pa1(listr.size());
//		for(size_t i=0;i<Pa1.size();++i)
//			Pa1[i]=pFirst2[listr[i]];
		// new random list
		std::vector<Particle> Pa1;
		{
			std::vector<double> listval(count,0.0);
			for(size_t i=0;i<listval.size();++i)
				listval[i]=randomu.doub();
			std::vector<int> listr;
			sortIndices(&listval[0],&listval[listval.size()],listr);
			assert(size_t(listr.size()*sizefactor)>5);
			listr.resize(size_t(listr.size()*sizefactor));
			Pa1.resize(listr.size());
			for(size_t i=0;i<Pa1.size();++i)
				Pa1[i]=pFirst2[listr[i]];
		}


		std::cout<<"Iter "<<j<<" "<<Pa1.size()<<std::endl;

		if(tnum==1)
			make_tree_bt(&Pa1[0],&Pa1[Pa1.size()],&Pa2[0],&Pa2[count],root,leafSize,dim,treeType,items,rotationOn);
		else
			make_tree_bt_par(&Pa1[0],&Pa1[Pa1.size()],&Pa2[0],&Pa2[count],root,leafSize,dim,treeType,items,rotationOn);
		std::vector<float>  pMetric(count*info[2],0.0);
//exit(1);
//		std::cout<<Pa1.capacity()<<" "<<listr.capacity()<<" "<<sizeof(root)<<" "<<pMetric.capacity()<<" "<<2*sizeof(NodeA)<<std::endl;
//		std::cout<<(Pa1.capacity()*sizeof(Pa1[0])*1e-6+listr.capacity()*sizeof(listr[0])*1e-6+sizeof(NodeA)*2*count*1e-6+pMetric.capacity()*4*1e-6)<<std::endl;
//		 printMetric1(pMetric,(pLast2-pFirst2),info[2]);

		if(j!=0)
		 {
			std::ifstream fin(fname, std::ios::in | std::ios::binary);
			 fin.read(reinterpret_cast<char *>(&info[0]),40);
			 fin.read(reinterpret_cast<char *>(&pMetric[0]),info[info[0]+2]*info[info[0]+3]);
			 fin.close();
		 }



		NodeA *currentNode;
		std::vector<NodeA*> nodeStack;
		nodeStack.push_back(root);
		while (nodeStack.size() > 0)
		{
			currentNode = nodeStack.back();
			nodeStack.pop_back();
			if (currentNode->leftN()!=NULL)
			{
				nodeStack.push_back(currentNode->rightN());
				nodeStack.push_back(currentNode->leftN());
			}
			else
			{
				if(rotationOn==1)
					currentNode->updateMatrix(pMetric,pStat,items);
				else
					currentNode->updateMetric(pMetric,pStat,items);
			}
		}

//		printMetric1(pMetric,(pLast2-pFirst2),info[2]);

		free(root);
		if(j==(iter_tot-1))
		{
			for(size_t i=0;i<pMetric.size();++i)
				pMetric[i]=pMetric[i]/iter_tot;
		}
		std::ofstream fout(fname, std::ios::out | std::ios::trunc | std::ios::binary);
		fout.write(reinterpret_cast<char *>(&info[0]),40);
		fout.write(reinterpret_cast<char *>(&pMetric[0]),info[info[0]+2]*info[info[0]+3]);
		fout.close();
	}
	t1.print("Bootstrapping time");

	std::vector<float>  pMetric(count*info[2],0.0);
	std::ifstream fin(fname, std::ios::in | std::ios::binary);
	fin.read(reinterpret_cast<char *>(&info[0]),40);
	fin.read(reinterpret_cast<char *>(&pMetric[0]),info[info[0]+2]*info[info[0]+3]);
	fin.close();

	printMetric1(pMetric,(pLast2-pFirst2),info[2]);
//	for(size_t i=0;i<pMetric.size();++i)
//		if(pMetric[i]==0.0)
//			{std::cout<<pMetric[i]<<std::endl; exit(1);}

	//	ofstream fout(fname, ios::out | ios::trunc | ios::binary);
	//	fout.write(reinterpret_cast<char *>(info),40);
	//	fout.write(reinterpret_cast<char *>(&pMetric[0]),info[1]*info[2]*info[info[0]+2]);
}


void pqStats::initialize(int dim)
{
	xmin.resize(dim);
	xmax.resize(dim);
	metric.resize(dim);
	searchcenter.resize(dim);
	searchx.resize(dim,std::vector<double> (2));
}

Tree::Tree( )
{
	dim=0;
	desNumNgb=10;
	numBucket=desNumNgb/2;
	root=NULL;
//	boundary=NULL;
}


void Tree::initialize(Particle* pBegin1,Particle* pEnd1, int desNumNgb1,int leafSize,int treeType,int dim1,int items1)
{
	dim=dim1;
	items=items1;
	desNumNgb=desNumNgb1;
//	desNumNgbA=desNumNgb1;
//	if(desNumNgb < 10)
//		desNumNgb=10;

	numBucket=desNumNgb/2;

	if(numBucket<8) numBucket=8;
	if(leafSize==0)
		leafSize=numBucket;
	make_tree(pBegin1,pEnd1,root,leafSize,dim,treeType,items);
//	buildTree(pBegin1,pEnd1,root,treeType);
//	pq.initialize(root->pFirst,root->pLast,desNumNgb, dim);
}

//void Tree::buildTreeA(Particle *pBegin,Particle* pEnd)
//{
//	int  max_iter=10;
//	int npart=pEnd-pBegin;
//	std::vector<int> list_kd(npart,0);
//	Particle *PartA;
//	for(int i=0;i<max_iter;++i)
//	{
//		for (i=0; i<list_kd.size(); i++)
//			list_kd[i]=rand()%npart;
//		sort(list_kd.begin(), list_kd.end());
//		std::vector<int>::iterator it=unique(list_kd.begin(), list_kd.end());
//		list_kd.resize(it-list_kd.begin());
//		PartA=new Particle[list_kd.size()];
//		for (i=0; i<list_kd.size(); i++)
//			PartA[i]=*(pBegin+list_kd[i]);
//
////		make_tree(PartA,PartA+list_kd.size(),rootA,dim,0);
////		rootA->setUp(PartA,PartA+list_kd.size());
//	}
//}


//void Tree::make_tree(Particle* pBegin1,Particle* pEnd1,Node*& root1,int dim1,int treeType)
//{
//	Node *currentNode, *lastCreatedNode;
//	std::vector<Node*> nodeStack;
//	ParticleStats pStat(dim1, (pEnd1-pBegin1),treeType);
//	//	std::cout<<"Building Tree ....";  std::cout.flush();
//	root1= new Node[2*(pEnd1-pBegin1)]; //for np particles nodes needed is 2*np-1 we keep one extra
//	root1->setUp(pBegin1,pEnd1,dim1,pStat);
//
//
//	lastCreatedNode=root1;
//	nodeStack.push_back(root1);
//
//	//	for(int k=0;k<dim;k++)
////	{
////			root->bnd[2*k]=pStat.xmin[k]* (1-(10*numeric_limits<float>::epsilon()));
////			root->bound(2*k+1)=pStat.xmax[k]*(1+(10*numeric_limits<float>::epsilon()));
////	}
//
//	while (nodeStack.size()>0)
//	{
//		currentNode=nodeStack.back();
//		if ((currentNode->pLast-currentNode->pFirst)>1)
//		{
//
////			if  ( (currentNode-root+2) > (root->pLast-root->pFirst)*2-2)
////			{
////				std::cout<<"number of nodes too large"<<std::endl;
////				exit(1);
////			}
//			currentNode->computeSplitParameters(dim1, pStat);
//			currentNode->left=lastCreatedNode+1;
////			currentNode->right=currentNode->left+1;
//			lastCreatedNode+=2;
//			currentNode->split(lastCreatedNode, pStat,dim1);
////			std::cout<<currentNode-root+1<<" "<<currentNode->kSplit1()<<"  "<<currentNode->xSplit1()<<std::endl;
////			if((currentNode-root+1)==981)
////				std::cout<<pStat.en[0]<<" "<<pStat.en[1]<<" "<<pStat.en[2]<<" "<<currentNode->parent->kSplit1()<<std::endl;
//		}
//		else
//		{
////			if ((currentNode->pLast-currentNode->pFirst)>1)
////			{
////				currentNode->computeSplitParameters(dim, pStat);
////				currentNode->left=new Node[2];
////				currentNode->right=currentNode->left+1;
////				currentNode->split(lastCreatedNode, pStat);
////			}
////			else
//			{
//				currentNode->left=NULL;
////				currentNode->right=NULL;
//			}
//		}
//		nodeStack.pop_back();
//
//		if (currentNode->left!=NULL)
//			nodeStack.push_back(currentNode->right());
//		if (currentNode->left!=NULL)
//			nodeStack.push_back(currentNode->left);
//	}
////	std::cout<<" Done"<<std::endl;
//}

//void Tree::buildTree(int treeType)
//{
//
//	Node *currentNode, *lastCreatedNode;
//	std::vector<Node*> nodeStack;
//	ParticleStats pStat(dim, (root->pLast-root->pFirst),treeType);
//	//	std::cout<<"Building Tree ....";  std::cout.flush();
//
//	lastCreatedNode=root;
//	nodeStack.push_back(root);
//
//	root->setUpBoundary(dim,pStat);
//	//	for(int k=0;k<dim;k++)
////	{
////			root->bnd[2*k]=pStat.xmin[k]* (1-(10*numeric_limits<float>::epsilon()));
////			root->bound(2*k+1)=pStat.xmax[k]*(1+(10*numeric_limits<float>::epsilon()));
////	}
//
//	while (nodeStack.size()>0)
//	{
//		currentNode=nodeStack.back();
//		if ((currentNode->pLast-currentNode->pFirst)>1)
//		{
//
////			if  ( (currentNode-root+2) > (root->pLast-root->pFirst)*2-2)
////			{
////				std::cout<<"number of nodes too large"<<std::endl;
////				exit(1);
////			}
//			currentNode->computeSplitParameters(dim, pStat);
//			currentNode->left=lastCreatedNode+1;
////			currentNode->right=currentNode->left+1;
//			lastCreatedNode+=2;
//			currentNode->split(lastCreatedNode, pStat,dim);
////			std::cout<<currentNode-root+1<<" "<<currentNode->kSplit1()<<"  "<<currentNode->xSplit1()<<std::endl;
////			if((currentNode-root+1)==981)
////				std::cout<<pStat.en[0]<<" "<<pStat.en[1]<<" "<<pStat.en[2]<<" "<<currentNode->parent->kSplit1()<<std::endl;
//		}
//		else
//		{
////			if ((currentNode->pLast-currentNode->pFirst)>1)
////			{
////				currentNode->computeSplitParameters(dim, pStat);
////				currentNode->left=new Node[2];
////				currentNode->right=currentNode->left+1;
////				currentNode->split(lastCreatedNode, pStat);
////			}
////			else
//			{
//				currentNode->left=NULL;
////				currentNode->right=NULL;
//			}
//		}
//		nodeStack.pop_back();
//
//		if (currentNode->left!=NULL)
//			nodeStack.push_back(currentNode->right());
//		if (currentNode->left!=NULL)
//			nodeStack.push_back(currentNode->left);
//	}
////	std::cout<<" Done"<<std::endl;
//}



void Tree::print()
{
	Node *currentNode;
	std::vector<Node*> nodeStack;
	nodeStack.push_back(root);
	while (nodeStack.size()>0)
	{
		currentNode=nodeStack.back();
		currentNode->print(root, root->pFirst);
		nodeStack.pop_back();
		if (currentNode->leftN()!=NULL)
			nodeStack.push_back(currentNode->rightN());
		if (currentNode->leftN()!=NULL)
			nodeStack.push_back(currentNode->leftN());
	}
//	pq.print();

}

Tree::~Tree()
{
	clear();
}

void Tree::clear()
{
//	long NumPart=root->pLast-root->pFirst;
//	for(int i=0;i<NumPart;i++)
//	{
//		delete [] scale[i].metric;
//		delete [] scale[i].matrix;
//	}
//	delete [] scale;
//	if (root != NULL)
//	{
//		if (root->type() == 0)
//		{
//			if (root->bnd != NULL)
//				delete[] root->bnd;
//		}
//		delete [] root;
//		root=NULL;
//	}
	if (root != NULL)
	{
		if (root->type() == 0)
		{
			if (root->bnd != NULL)
				free(root->bnd);
		}
		free(root);
		root=NULL;
	}
}


void Tree::knn_scatter(double* xyz, int *nlist)
{

}

void Tree::knn_bruteForce(const double *searchcenter, const double *metric,ParticlePriorityQueue &pq)
{
	pq.reset(searchcenter, metric);
	for (Particle* Part=root->pFirst; Part<root->pLast; Part++)
	{
		pq.push1(Part);
//		pq.push<3>(Part);
	}
}

//static std::vector<double> ky;
//static int count2,count3;
void (ParticlePriorityQueue::*funct)(Particle* ) = NULL;

void Tree::smoothMetric(double *metric,std::vector<float>  &pMetric,ParticlePriorityQueue &pq)
{
	for(int k=0;k<dim;++k)
		metric[k]=0;
	for(Neighbor* ngb=pq.begin();ngb<pq.end();ngb++)
	{
		for(int k=0;k<dim;++k)
			metric[k]+=pMetric[ngb->Pa->ID(items)*dim+k];
	}
	for(int k=0;k<dim;++k)
		metric[k]=1.0/sqrt(metric[k]/pq.size());
}
void Tree::smoothMatrix(double *metric,std::vector<float>  &pMetric,ParticlePriorityQueue &pq)
{
	int dim1=(dim*(dim+1))/2;
	for(int k=0;k<dim1;++k)
		metric[k]=0;
	for(Neighbor* ngb=pq.begin();ngb<pq.end();ngb++)
	{
		for(int k=0;k<dim1;++k)
			metric[k]+=pMetric[ngb->Pa->ID(items)*dim1+k];
	}
	for(int k=0;k<dim1;++k)
		metric[k]*=(1.0/pq.size());
}

void Tree::readGlobalMetricFromFile(double* metric,Parameters &All)
{
  for(int i=0;i<dim;++i)
    if (i <All.metric_default.size())
      {
	metric[i]=All.metric_default[i];
      }
    else
      {
	std::cout<<"Not enough metric elements in All.metric_default, setting rest to 1"<<std::endl;
	metric[i]=1.0;
      }
      
      
      
	// FILE* fd;
	// float temp;
	// int nread=0;
	// if((fd=fopen("metric_default.txt","r")))
	// {
	// 	for(int i=0;i<dim;++i)
	// 	{
	// 		nread=fscanf(fd,"%f",&temp);
	// 		metric[i]=temp;
	// 		if(feof(fd))
	// 		{
	// 			std::cout<<"Not enough data records"<<std::endl;
	// 			fclose(fd);
	// 			exit(1);
	// 		}
	// 	}
	// 	fclose(fd);
	// }
	// else
	// {
	// 	std::cout<<"file not found: metric_default.txt"<<std::endl;
	// 	exit(1);
	// }

}

void Tree::densityAll(Parameters &All,ebf::EbfFile &ebf_density,ebf::EbfFile &ebf_metric,std::vector<float>  &pMetric)
{
//	int vci=0;
	//	All.PeriodicBoundaryOn=0;
	if(All.PeriodicBoundaryOn==1)
	{
		ParticleStats1 pStat(dim);
		pStat.computeMinMaxSig(root->pFirst,root->pLast,0,dim);
		lp.resize(dim);
		for(int k=0;k<dim;++k)
			lp[k]=pStat.xmax[k]-pStat.xmin[k];
	}

	//	Normaldev randn(0.0,1.0,3l);
	int ImageOn=0;
	Image im(dim);
	if (All.ImageFile.size()!=0)
	{
		ImageOn=1;
		im.init(0.0,0.0,0.0,10.0,128);
	}
		//------------------

//	#pragma omp parallel
	{
//		FILE* fp_local=fp_ngb;

	bool* imark;
	imark=new bool[root->pLast-root->pFirst];
	for(int i=0;i<(root->pLast-root->pFirst);++i)
		imark[i]=0;
	ParticlePriorityQueue pq;
	pq.initialize(root->pFirst,root->pLast,desNumNgb, dim);
	pq.setImarkB(&imark[0]);

	pinfo pinfo1;
	pinfo1.ngbList.resize(desNumNgb-1);
	pinfo1.rList.resize(desNumNgb-1);
	int nMerge;
	nMerge=(desNumNgb>9) ? 9: (desNumNgb-1);
//	nMerge=8;
	double* metric=new double[dim*dim];
	double* metricsave=new double[dim*dim];
	for(int k=0;k<dim;++k)
		metric[k]	=1.0;

	if(All.NormalEuclideanMetricOn==1)
		setNormalMetric(metric);

	if((All.NormalEuclideanMetricOn==2)||(All.NormalEuclideanMetricOn==3))
	  readGlobalMetricFromFile(metric,All);

//	metric[0]=0.001;	metric[1]=1.0;	metric[2]=1.0;
//	metric[3]=1.0;	metric[4]=1.0;	metric[5]=1.0;
//	for(int k=3;k<dim;++k)
//		metric[k]	=1.0;
	std::vector<double> metric1(dim,0.0),metric2(dim,0.0);

	double temp;
//count2=0; count3=0;
	pqStats pq_stats;
	pq_stats.initialize(dim);
	std::vector<class node_list> box_list;
//	 funct=&ParticlePriorityQueue::push<3>;

	if((All.CubicCellsOn==1)&&(dim!=6))
	{
		std::cout<<"cubic cells allowed only for dim=6 here dim="<<dim<<std::endl;
		exit(1);
	}

	Kernel* kerp;
	if(All.NormalEuclideanMetricOn==3)
	{
		assert(dim>=3);
		kerp= new Kernel(1000,dim-1,All.TypeOfKernel,All.KernelBiasCorrectionOn,All.DensityScatter);
	}
	else
		kerp= new Kernel(1000,dim,All.TypeOfKernel,All.KernelBiasCorrectionOn,All.DensityScatter);

//	Kernel ker(1000,dim,All.TypeOfKernel,All.KernelBiasCorrectionOn,All.DensityScatter);

	Particle *Part;
	Timer timer1;	timer1.start();


//	ExtBinFormat ebf1;
	// openmp	begin
//	int tid=omp_get_thread_num();
//	int tnum=omp_get_num_threads();
//	char buf1[256];
//	sprintf(buf1,"%s%s%d%s",All.InitCondFile,"_",tid,".tmp.ebf");
//	Particle *PartF=root->pFirst+tid*(root->count()/tnum);
//	Particle *PartL=root->pFirst+(tid+1)*(root->count()/tnum);
//	 if(All.NgblistOn&&(tnum>1))
//	 {
//		 ebf1.initialize(buf1,"w","/NGB_LIST",2,(PartL-PartF),(nMerge+1));
//		 fp_local=ebf1.fp();
//	 }
//	if((tid+1)==tnum)
//		PartL=root->pLast;
	// openmp	end

	for(int k=0;k<dim;++k)
		metricsave[k]=metric[k];

	Particle *PartF=root->pFirst;
	Particle *PartL=root->pLast;
	int i1=0,pi=(PartL-PartF)%100+(PartL-PartF)/100;

	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::setw(12)<<std::right<<"% Completed"<<std::setw(16)<<"Time Left"<<std::setw(16)<<"Est Tot time"<<std::setw(12)<<"Par ID"<<std::setw(16)<<"Density"<<std::endl;
	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
	for(Particle* Part1=PartF;Part1<PartL;Part1++)
	{
// Non openmp	begin
//	int i1=0,pi=root->count()%100+root->count()/100;
//	for(Particle* Part1=root->pFirst;Part1<root->pLast;Part1++)
//	{
// Non openmp	end
		Part=Part1;
		while(imark[Part-(root->pFirst)] ==0 )
		{
			for(int k=0;k<dim;++k)
				metric[k]=metricsave[k];

			if(All.TypeOfSmoothing==3)
			{
				if(All.BootstrapOn==1)
				{
//					std::cout<<Part->ID(items)<<" "<<pMetric.size()<<std::endl;

					if(All.RotationOn==1)
					{
						int dim1=(dim*(dim+1))/2;
						for(int k=0;k<dim1;++k)
						{
							metric[k]=pMetric[Part->ID(items)*dim1+k];
						}
					}
					else
					{
						for(int k=0;k<dim;++k)
							metric[k]=1.0/sqrt(pMetric[Part->ID(items)*dim+k]);
					}
//					std::cout<<"metric"<<metric[0]<<" "<<metric[1]<<" "<<metric[2]<<" "<<metric[3]<<" "<<metric[4]<<" "<<metric[5]<<" "<<std::endl;
//					std::cout<<"metric"<<pMetric[Part->ID(items)*dim1+0]<<" "<<pMetric[Part->ID(items)*dim1+1]<<" "<<pMetric[Part->ID(items)*dim1+2]<<std::endl;
				}
				else
				{
//					timer2.resume();
					computeMetric(Part->Pos,metric,box_list,pq_stats);
//					timer2.stop();
				}
				if(All.CubicCellsOn==1)
					makeCubic(metric);
			}

//			if(All.TypeOfSmoothing==2)
//			{
//			if(dim>=3) 1.48621e+00 3.05973e+00 1.07507e-01 8.75424e+00 7.91767e+00 2.62425e+00
//				1.06026e+01 2.50441e+01 2.31598e-01 1.02403e+00 1.02240e+00 3.60303e-01
//				float a3[]={4.45721e+00, 4.01882e+00, 5.36415e+00, 3.37457e-01, 3.23831e-01, 4.31907e-01};
//				float a3[]={1.0, 1.0, 0.5e-7, 0.35, 0.35, 0.35};
//				float a3[]={1.0, 1.0, 1.0, 2.0, 2.0, 2.0};
//				for(int k=0;k<dim;++k)
//				{
//					metric[k]	=a3[k];
//				}
//				metric[0]=1.48e+00;metric[1]=3.05e+00 ;metric[2]=1.07e-01;
//				metric[0]=1.48e+00;metric[1]=3.05e+00 ;metric[2]=1.07e-01;
//				metric[3]=8.75e+00;metric[4]=7.92e+00;metric[5]= 2.62e00;
//				metric[0]=1.06e+01;metric[1]=2.50e+01 ;metric[2]=2.31e-01;
//				metric[3]=1.02e+00;metric[4]=1.02e+00;metric[5]= 3.60e-01;
			//			{	metric[0]=117.0; metric[1]=320.0; metric[2]=1.75;}
//			if(dim==6)
//			{metric[3]=0.1; metric[4]=0.1; metric[5]=0.16;}
//			}
			//			temp=*max_element(metric,metric+dim);

			temp=1.0;
			if(All.RotationOn!=1)
			{
				for(int k=0;k<dim;++k)
				{
					temp*=metric[k];
				}
				temp=pow(temp,1.0/dim);
			}
			for(int k=0;k<dim;++k)
			{
				metric1[k]+=metric[k]/temp;
				metric2[k]+=metric[k]*metric[k]/(temp*temp);
			}
//			printv("metric-->",metric,metric+dim);
//			printv("metric1-->",metric1.begin(),metric1.end());
//			printv("metric2-->",metric2.begin(),metric2.end());


			//			temp=sqrt(metric[0]*metric[2]);
//			metric[0]=temp;
//			metric[1]=temp;

//			std::cout<<i1<<" metric"<<metric[0]<<" "<<metric[1]<<" "<<metric[2]<<" "<<metric[3]<<" "<<metric[4]<<" "<<metric[5]<<" "<<std::endl;
			if(All.RotationOn==1)
				ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
			else
				ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);
			if(All.BootstrapOn==1)
			{
				if(All.RotationOn==1)
				{
					smoothMatrix(metric,pMetric,pq);
					ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
				}
				else
				{
					smoothMetric(metric,pMetric,pq);
//					temp=sqrt(metric[0]*metric[1]);
//					metric[0]=temp ; metric[1]=temp;
					ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);
				}
			}


//			if((All.TypeOfSmoothing==2)||(All.TypeOfSmoothing==3))
			if(All.TypeOfSmoothing==3)
			if(All.RotationOn==0)
			if(All.VolCorrOn)
			{
//				std::cout<<metric[0]<<" "<<metric[1]<<std::endl;
				if(checkVol2(Part->Pos,metric,pq,pq_stats))
				{
//					vci++;
//					std::cout<<metric[0]<<" "<<metric[1]<<std::endl;
					if(All.CubicCellsOn==1)
						makeCubic(metric);
					if(All.RotationOn==1)
						ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
					else
						ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);

				}
			}

//--------------------------------------------------------------
// testing brute force
//			std::vector<Neighbor> check_idv1,check_idv2;
//			for(Neighbor* ngb=pq.begin();ngb<pq.end();ngb++)
//				check_idv1.push_back(*ngb);
//			knn_bruteForce(Part->Pos,metric,pq);
//			for(Neighbor* ngb=pq.begin();ngb<pq.end();ngb++)
//				check_idv2.push_back(*ngb);
//			sort(check_idv1.begin(),check_idv1.end());
//			sort(check_idv2.begin(),check_idv2.end());
//			for(size_t k=0;k<check_idv1.size();++k)
//			{
//				if(check_idv1[k].Pa->ID(items)!=check_idv2[k].Pa->ID(items))
//				{
//					std::cout<<"Error found"<<std::endl;
//					for(size_t j=0;j<check_idv1.size();++j)
//					{
//						std::cout<<check_idv1[j].Pa->ID(items)<<" "<<check_idv1[j].r<<" "<<check_idv2[j].Pa->ID(items)<<" "<<check_idv1[j].r<<std::endl;
//					}
//					break;
////					exit(1);
//				}
//			}
//			std::cout<<"OK"<<std::endl;
//--------------------------------------------------------------
//			if(desNumNgb==All.DesNumNgbA)
				kerp->computeDensity(Part,pq,metric,items);
//			else
//				kerp->computeDensityN(Part,pq,metric,items,All.DesNumNgbA);

			if(All.NormalEuclideanMetricOn==3)
				Part->Density(items)/=metric[2];

			if(All.MetricOn==1)
				saveMetric(metric,sqrt(pq.top().r),ebf_metric);

//			Part->Density(items)=checkVol2(Part->Pos,metric,pq,pq_stats);
//			std::cout<<Part->Density(items)<<std::endl;

			if(ImageOn==1)
			{
				if(All.RotationOn==1)
					im.updateR(Part->Pos,metric,sqrt(pq.top().r));
				else
					im.update(Part->Pos,metric,sqrt(pq.top().r));
			}

			//			if(ImageOn==1)
//				if(All.RotationOn==1)
//					im.update2(Part->Pos,metric,sqrt(pq.top().r),Part->Density(items));
//				else
//					im.update(Part->Pos,metric,sqrt(pq.top().r),Part->Density(items));

			if(All.NgblistOn)
			{
		  		pinfo1.pi=Part->ID(items);
		  		pq.ngbList(Part->ID(items),pinfo1.ngbList,pinfo1.rList,items);
//				pinfo1.printToFile(fp_ngb,nMerge);
				pinfo1.printToFile(ebf_density,nMerge);
			}

//			 std::cout<<metric[0]<<" "<<metric[1]<<" "<<metric[2]<<std::endl;
//			 std::cout<<fixed<<setprecision(2)<<std::setw(12)<<((i1)*100)/(root->count())<<std::setw(12)<<timer1.currentTime()*(root->count()-i1-1)*1.0/(i1)<<std::setw(12)<<timer1.currentTime()*root->count()*1.0/(i1)<<std::setw(12)<<Part->ID(items)+1<<std::setw(16)<<setprecision(5)<<scientific<<Part->Density(items)<<std::endl;

				i1++;
		  		if(i1==pi)
		  		{
		  			pi=pi+root->count()/100;
		  			std::cout<<std::fixed<<std::setprecision(2)<<std::setw(12)<<((i1)*100.0)/(root->count())<<std::setw(16)<<timer1.currentTime()*(root->count()-i1-1)*1.0/(i1)<<std::setw(16)<<timer1.currentTime()*root->count()*1.0/(i1)<<std::setw(12)<<Part->ID(items)+1<<std::setw(16)<<std::setprecision(5)<<std::scientific<<Part->Density(items)<<std::endl;
//		  			timer2.print("metric time ");
		  			//		  			std::cout<<fixed<<setprecision(2)<<std::setw(12)<<((i1)*100)/(root->count())<<std::endl;
//		  			std::cout<<std::setw(12)<<timer1.currentTime()*(root->count()-i1-1)*1.0/(i1)<<std::endl;
//		  			std::cout<<std::setw(12)<<timer1.currentTime()*root->count()*1.0/(i1)<<std::setw(12)<<Part->ID(items)+1<<std::endl;
//		  			std::cout<<std::setw(16)<<setprecision(5)<<scientific<<Part->Density(items)<<std::endl;
		  			fflush(stdout);
		  		}

		  		imark[(Part-root->pFirst)]=1;
//		  		Part=pq.pNext();

		}
	}
	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::left;

	for(int k=0;k<dim;++k)
	{
		metric1[k]/=(root->pLast-root->pFirst);
		metric2[k]/=(root->pLast-root->pFirst);
		metric2[k]-=metric1[k]*metric1[k];
		metric2[k]=sqrt(fabs(metric2[k]))/metric1[k];
	}
	if(All.RotationOn!=1)
	{
		printv("mean  metric-->",metric1.begin(),metric1.end());
		printv("sigma metric-->",metric2.begin(),metric2.end());
	}
//	std::cout<<"Metric Stats "<<metric1[2]/sqrt(metric1[0]*metric1[1])<<" "<<metric1[2]*sqrt(8)/sqrt(metric1[0]*metric1[1])<<std::endl;
//	std::cout<<"Metric Stats "<<metric[2]/sqrt(metric[0]*metric[1])<<" "<<metric[2]*sqrt(8)/sqrt(metric[0]*metric[1])<<std::endl;

//	if(pMetric.size()>0)
//		printMetric1(pMetric,root->pLast-root->pFirst,dim);

//	std::cout<<"VC_ratio"<<vci*1.0/(root->pLast-root->pFirst)<<" "<<vci<<std::endl;

	pq.clearImarkB( );
	delete [] metric;
	delete [] metricsave;
	delete [] imark;
	delete kerp;

//	if(All.NgblistOn)
//		 ebf1.close();

//	if(All.Extra==1)
//		for(Particle* Part=(root->pFirst);Part<(root->pLast);Part++)
//		{
//			Part->Density(items)=Part->Mass(items);
//		}
	std::cout<<"Done"<<std::endl;

	if(ImageOn)
	{
		if(All.asciiOn==1)
			im.writeascii(All.ImageFile);
		else
			im.write(All.ImageFile);
	}
	}



}


void Tree::density(const std::string& targetfile,const std::string& outfile, Parameters &All,std::vector<float>  &pMetric)
{
	ParticleData pDataIn;
	pDataIn.readFromFile(targetfile.c_str(),dim,"");
	std::vector<double> density(pDataIn.size());

//	size_t nsize=1000;
//	int pitems=3;
//	double* pdata= new double[nsize*items];
//	Particle* partIn= new Particle[nsize];
//	for(size_t i=0;i<nsize;i++)
//			partIn[i].Pos=&data[i*items];
//

	if(All.PeriodicBoundaryOn==1)
	{
		ParticleStats1 pStat(dim);
		pStat.computeMinMaxSig(root->pFirst,root->pLast,0,dim);
		lp.resize(dim);
		for(int k=0;k<dim;++k)
			lp[k]=pStat.xmax[k]-pStat.xmin[k];
	}

	bool* imark;
	imark=new bool[root->pLast-root->pFirst];
	for(int i=0;i<(root->pLast-root->pFirst);++i)
		imark[i]=0;
	ParticlePriorityQueue pq;
	pq.initialize(root->pFirst,root->pLast,desNumNgb, dim);
	pq.setImarkB(&imark[0]);

	pinfo pinfo1;
	pinfo1.ngbList.resize(desNumNgb-1);
	pinfo1.rList.resize(desNumNgb-1);
	int nMerge;
	nMerge=(desNumNgb>9) ? 9: (desNumNgb-1);
	double* metric=new double[dim*dim];
	double* metricsave=new double[dim*dim];
	for(int k=0;k<dim;++k)
		metric[k]	=1.0;

	if(All.NormalEuclideanMetricOn==1)
		setNormalMetric(metric);

	if((All.NormalEuclideanMetricOn==2)||(All.NormalEuclideanMetricOn==3))
	  readGlobalMetricFromFile(metric,All);

	std::vector<double> metric1(dim,0.0),metric2(dim,0.0);

	double temp;
	pqStats pq_stats;
	pq_stats.initialize(dim);
	std::vector<class node_list> box_list;

	if((All.CubicCellsOn==1)&&(dim!=6))
	{
		std::cout<<"cubic cells allowed only for dim=6 here dim="<<dim<<std::endl;
		exit(1);
	}

	Kernel* kerp;
	if(All.NormalEuclideanMetricOn==3)
	{
		assert(dim>=3);
		kerp= new Kernel(1000,dim-1,All.TypeOfKernel,All.KernelBiasCorrectionOn,All.DensityScatter);
	}
	else
		kerp= new Kernel(1000,dim,All.TypeOfKernel,All.KernelBiasCorrectionOn,All.DensityScatter);


	Particle *Part;
	Timer timer1;	timer1.start();



	for(int k=0;k<dim;++k)
		metricsave[k]=metric[k];

	int i1=0,pi=pDataIn.size()%100+pDataIn.size()/100;

	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::setw(12)<<std::right<<"% Completed"<<std::setw(16)<<"Time Left"<<std::setw(16)<<"Est Tot time"<<std::setw(12)<<"Par ID"<<std::setw(16)<<"Density"<<std::endl;
	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
//	for(Particle* Part1=PartF;Part1<PartL;Part1++)
	for(int i=0;i<pDataIn.size();++i)
	{
		Part=&pDataIn.part[i];

			for(int k=0;k<dim;++k)
				metric[k]=metricsave[k];

			if(All.TypeOfSmoothing==3)
			{
				if(All.BootstrapOn==1)
				{
					std::cout<<"Option BootStrap not allowed"<<std::endl;
				}
				else
				{
					computeMetric(Part->Pos,metric,box_list,pq_stats);
				}
				if(All.CubicCellsOn==1)
					makeCubic(metric);
			}


			temp=1.0;
			if(All.RotationOn!=1)
			{
				for(int k=0;k<dim;++k)
				{
					temp*=metric[k];
				}
				temp=pow(temp,1.0/dim);
			}
			for(int k=0;k<dim;++k)
			{
				metric1[k]+=metric[k]/temp;
				metric2[k]+=metric[k]*metric[k]/(temp*temp);
			}


			if(All.RotationOn==1)
				ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
			else
				ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);
			if(All.BootstrapOn==1)
			{
				if(All.RotationOn==1)
				{
					smoothMatrix(metric,pMetric,pq);
					ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
				}
				else
				{
					smoothMetric(metric,pMetric,pq);
					ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);
				}
			}


			if(All.TypeOfSmoothing==3)
			if(All.RotationOn==0)
			if(All.VolCorrOn)
			{
				if(checkVol2(Part->Pos,metric,pq,pq_stats))
				{
					if(All.CubicCellsOn==1)
						makeCubic(metric);
					if(All.RotationOn==1)
						ngb_treesearch_sphere_matrix_im(Part->Pos,metric,box_list,pq);
					else
						ngb_treesearch_sphere_metric_im(Part->Pos,metric,box_list,pq);

				}
			}

			density[i]=kerp->computeDensityGen(pq,metric,items);
//			else
//				kerp->computeDensityN(Part,pq,metric,items,All.DesNumNgbA);

			if(All.NormalEuclideanMetricOn==3)
				density[i]/=metric[2];

//			std::cout<<Part->Pos[0]<<" "<<Part->Pos[1]<<" "<<density[i]<<std::endl;

			i1++;
			if(i1==pi)
			{
				pi=pi+pDataIn.size()/100;
				std::cout<<std::fixed<<std::setprecision(2)<<std::setw(12)<<((i1)*100.0)/(root->count())<<std::setw(16)<<timer1.currentTime()*(root->count()-i1-1)*1.0/(i1)<<std::setw(16)<<timer1.currentTime()*root->count()*1.0/(i1)<<std::setw(12)<<i+1<<std::setw(16)<<std::setprecision(5)<<std::scientific<<density[i]<<std::endl;
				fflush(stdout);
			}
	}
	std::cout<<"-------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::left;

	for(int k=0;k<dim;++k)
	{
		metric1[k]/=(root->pLast-root->pFirst);
		metric2[k]/=(root->pLast-root->pFirst);
		metric2[k]-=metric1[k]*metric1[k];
		metric2[k]=sqrt(fabs(metric2[k]))/metric1[k];
	}
	if(All.RotationOn!=1)
	{
		printv("mean  metric-->",metric1.begin(),metric1.end());
		printv("sigma metric-->",metric2.begin(),metric2.end());
	}

	pq.clearImarkB( );
	delete [] metric;
	delete [] metricsave;
	delete [] imark;
	delete kerp;

	ebf::Write(outfile,"/Density",&density[0],"w","",pDataIn.size());


}


//std::cout<<"Metric=[ ";
//for(int i=0;i<dim;++i)
//std::cout<<metric[i]<<" ";
//std::cout<<" ]"<<std::endl;


//static std::vector<class node_list> box_list;

//void Tree::ngb_treesearch_sphere_metric_im(const double *searchcenter,const double *metric,std::vector<node_list> &box_list,void (ParticlePriorityQueue::*funct)(Particle*))
void Tree::ngb_treesearch_sphere_metric_im(const double *searchcenter,const double *metric,std::vector<node_list> &box_list,ParticlePriorityQueue &pq)
//void Tree::ngb_treesearch_sphere_metric_im( )
{
//	bool b1=0;
	int k;
	Node *cp;
	double temp1, temp2, r2;
//	std::vector<class node_list> box_list;
	class node_list box;
	pq.reset(searchcenter, metric);
//Node*	cp1=root;
//	while(cp1->count()>desNumNgb)
//	{
//	    if((pq.searchCenter[cp1->get_kSplit()]) < cp1->get_xSplit())
//		cp1=cp1->left;
//	    else
//		cp1=cp1->right();
//	}
// 	while(cp1->count()<desNumNgb)
//	{
// 	    cp1=cp1->parent;
//	}
//	for (Particle* Part=cp1->pFirst; Part<cp1->pLast; Part++)
//		pq.push1(Part);


	// 	std::cout<<cp<<" "<<box_list.size();
//int 	i=0;
//	box_list[0].initialize(root,0.0);
	box_list.clear();
	box.initialize(root,0.0);
	box_list.push_back(box);

//	while (i>-1)
	if(lp.size()==0)
	{
		while (!box_list.empty())
	{
		cp=box_list.back().cp;
		r2=box_list.back().r2;
		box_list.pop_back();
//		cp=box_list[i].cp;
//		r2=box_list[i].r2;
//		i--;

		if (r2>=pq.top().r)
			continue;

		if (cp->count()>numBucket)
		{
			k=cp->get_kSplit();

			if (cp->get_xSplit() > pq.searchx[k][1])
			{
				box.initialize(cp->leftN(),r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
//				i++;
//				box_list[i].initialize(cp->leftN(),r2);
				continue;
			}
			//			else if (cp->get_xSplit() < pq.searchx[k][0])
			if (cp->get_xSplit() < pq.searchx[k][0])
			{
				box.initialize(cp->leftN()+1,r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
//				i++;		box_list[i].initialize(cp->leftN()+1,r2);
				continue;
			}
//			else if (cp->get_xSplit() > pq.searchCenter[k])
//			std::cout<<"here21"<<" "<<cp->count()<<std::endl;

			temp1=(pq.searchCenter[k]-cp->get_xSplit())*pq.metric[k];
			temp1*=temp1;
			if (cp->get_xSplit() > pq.searchCenter[k])
			{
				temp2=(cp->xb(0)<pq.searchCenter[k]) ? 0.0 : (cp->xb(0) - pq.searchCenter[k])*pq.metric[k];
				temp2*=temp2;
				temp1+=r2-temp2;

//				if (temp1<pq.top().r)
//					{i++;box_list[i].initialize(cp->leftN()+1,temp1);}
				box.initialize(cp->leftN()+1,temp1);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
//					if (r2<pq.top().r)
//				{i++;box_list[i].initialize(cp->leftN(),r2);}
				box.initialize(cp->leftN(),r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
			}
			else
			{
				temp2=(cp->xb(1)>pq.searchCenter[k]) ? 0.0 : (pq.searchCenter[k]-cp->xb(1))*pq.metric[k];
				temp2*=temp2;
				temp1+=r2-temp2;
//				if (temp1<pq.top().r)
//				{i++;box_list[i].initialize(cp->leftN(),temp1);}
				box.initialize(cp->leftN(),temp1);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
//				if (r2<pq.top().r)
//				{i++;box_list[i].initialize(cp->leftN()+1,r2);}
				box.initialize(cp->leftN()+1,r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
			}
		}
		else
		{

			//			if(cp!=cp1)
//			pq.pushAll<3>(cp->pFirst,cp->pLast);
			for (Particle* Part=cp->pFirst; Part<cp->pLast; Part++)
					pq.push1(Part);

//					(pq.*funct)(Part);
		}
	}
	}
	else
	{
		while (!box_list.empty())
	{
		cp=box_list.back().cp;
		r2=box_list.back().r2;
		box_list.pop_back();

		if (r2>=pq.top().r)
			continue;

		if (cp->count()>numBucket)
		{
			k=cp->get_kSplit();

			if (cp->get_xSplit() > pq.searchx[k][1])
				if ((cp->xb(1) - lp[k]) < pq.searchx[k][0])
			{
				box.initialize(cp->leftN(),r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
				continue;
			}
			if (cp->get_xSplit() < pq.searchx[k][0])
				if ((cp->xb(0) + lp[k]) > pq.searchx[k][1])
			{
				box.initialize(cp->leftN()+1,r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
				continue;
			}

				box.initialize(cp->leftN()+1,r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
				box.initialize(cp->leftN(),r2);
				if (box.r2<pq.top().r)
					box_list.push_back(box);
		}
		else
		{
			for (Particle* Part=cp->pFirst; Part<cp->pLast; Part++)
					pq.push1(Part,&lp[0]);
		}
	}

	}

//	double density=pq.density();
//	pq.ngbList(parent,ngbList);

//	return density;
}




void Tree::ngb_treesearch_sphere_matrix_im(const double *searchcenter,const double *metric,std::vector<node_list> &box_list,ParticlePriorityQueue &pq)
{
	int k;
	Node *cp;
//	double temp1, temp2, r2;
	class node_list box;
	pq.reset2(searchcenter, metric);
//	int dim1=(dim*(dim+1))/2;
//	for(int k=0;k<dim1;++k)
//		std::cout<<k<<" "<<metric[k]<<std::endl;
//	std::cout<<"center "<<searchcenter[0]<<" "<<searchcenter[1]<<std::endl;
//	std::cout<<pq.searchx[0][0]<<" "<<pq.searchx[0][1]<<" "<<pq.searchx[1][0]<<" "<<pq.searchx[1][1]<<std::endl;

	box_list.clear();
	box.initialize(root,0.0);
	box_list.push_back(box);

	while (!box_list.empty())
	{
		cp=box_list.back().cp;
		box_list.pop_back();


		if (cp->count()>numBucket)
		{
			k=cp->get_kSplit();

			if (cp->get_xSplit() > pq.searchx[k][1])
			{
				box.initialize(cp->leftN(),0.0);
				box_list.push_back(box);
				continue;
			}
			if (cp->get_xSplit() < pq.searchx[k][0])
			{
				box.initialize(cp->leftN()+1,0.0);
				box_list.push_back(box);
				continue;
			}

			if (cp->get_xSplit() > pq.searchCenter[k])
			{
				box.initialize(cp->leftN()+1,0.0);
				box_list.push_back(box);
				box.initialize(cp->leftN(),0.0);
				box_list.push_back(box);
			}
			else
			{
				box.initialize(cp->leftN(),0.0);
				box_list.push_back(box);
				box.initialize(cp->leftN()+1,0.0);
				box_list.push_back(box);
			}
		}
		else
		{
//			if(cp->count()<=0)
//			{
//				std::cout<<"Problem"<<std::endl;
//				exit(1);
//			}
			for (Particle* Part=cp->pFirst; Part<cp->pLast; Part++)
					pq.push2(Part);
		}
	}


}


void Tree::saveMetric(double* metric,double factor,ebf::EbfFile &ebf_metric)
{
		for(int k=0;k<dim;++k)
			dummy[k]=factor/metric[k];
		ebf_metric.Write(&dummy[0],dim);
}


//void Tree::computeMetricIsochrone(double x1,double x2,std::vector<double> &xv)
//{
//	for(int i=0;i<xv.size();++i)
//	{
//		scale[i].metric[0]=x1;
//		scale[i].metric[1]=xv[i];
//	}
//
//	double *temp;
//	for(int i=0;i<xv.size();++i)
//	{
//		temp=min_element(scale[i].metric,scale[i].metric+dim);
//		for(int k=0;k<dim;++k)
//			scale[Part-root->pFirst].metric[k]/=(*temp);
//	}
//}

void Tree::computeMetricGeneral( )
{
//	for(int i=0;i<xv.size();++i)
//	{
//		scale[i].metric[0]=x1;
//		scale[i].metric[1]=xv[i];
//	}
//
//	double *temp;
//	for(int i=0;i<xv.size();++i)
//	{
//		temp=min_element(scale[i].metric,scale[i].metric+dim);
//		for(int k=0;k<dim;++k)
//			scale[Part-root->pFirst].metric[k]/=(*temp);
//	}
}


void Tree::getMetric(Particle* Part,double *metric)
{
//	for(int k=0;k<dim;++k)
//		metric[k]=scale[Part-root->pFirst].metric[k]	;
}

void Tree::makeCubic(double *metric)
{
	double temp=pow((metric[0]*metric[1]*metric[2]),0.3333);
	metric[0]=temp;	metric[1]=temp;	metric[2]=temp;
	temp=pow((metric[3]*metric[4]*metric[5]),0.3333);
	metric[3]=temp;	metric[4]=temp;	metric[5]=temp;
}

void Tree::setNormalMetric(double *metric)
{
	ParticleStats1 pstat(dim);
	pstat.computeMinMaxSig(root->pFirst,root->pLast,0,dim);
	for(int k=0;k<dim;++k)
		metric[k]=1.0/pstat.xsig[k];
}


int Tree::checkVol(double* xyz,double* metric,ParticlePriorityQueue &pq,pqStats &pq_stats)
{
	int status=0,k;
	if (lp.size()==0)
		return 0;

	for(k=0;k<dim;++k)
	{
		pq_stats.xmin[k]=pq.begin()->Pa->Pos[k]	 ;
		pq_stats.xmax[k]=pq.begin()->Pa->Pos[k]	 ;
	}
	for(Neighbor* ngb=pq.begin();ngb<pq.end();ngb++)
	{
		for(k=0;k<dim;++k)
		{
		if(ngb->Pa->Pos[k]<pq_stats.xmin[k])
			pq_stats.xmin[k]=ngb->Pa->Pos[k];
		if(ngb->Pa->Pos[k]>pq_stats.xmax[k])
			pq_stats.xmax[k]=ngb->Pa->Pos[k];
		}
	}
	double temp=sqrt(pq.top().r),temp1;
	for(k=0;k<dim;++k)
		pq_stats.metric[k]=temp/metric[k];
	double coeff=3.0*(1+1.0/sqrt(1.0*pq.size()))/pow(pq.size(),1.0/dim);
	for(k=0;k<dim;++k)
	{
		// old
//		temp1=(pq_stats.xmax[k]-pq_stats.xmin[k])*25.0/pq.size();
// new better improvement 24-2,2010
		temp1=(pq_stats.xmax[k]-pq_stats.xmin[k])*coeff;
		if(((pq_stats.xmin[k]-(xyz[k]- pq_stats.metric[k])) >temp1)&&(((xyz[k]+ pq_stats.metric[k])-pq_stats.xmax[k]) >temp1))
			break;
	}
	if(k!=dim)
	{
		status=1;
		for(k=0;k<dim;++k)
		{
//			std::cout<<pq_stats.xmax[k]<<" "<<pq_stats.xmin[k]<<std::endl;
			if(pq_stats.xmax[k]!=pq_stats.xmin[k])
				metric[k]=2.0/(pq_stats.xmax[k]-pq_stats.xmin[k]);
		}
	}
//	std::cout<<status<<std::endl;
	return status;
}

inline double periodic(double temp,double l)
{
	if((2*temp)>l)
		temp-=l;
	else if((2*temp)<(-l))
		temp+=l;
	return temp;
}

int Tree::checkVol2(double* xyz, double* metric, ParticlePriorityQueue &pq,
		pqStats &pq_stats)
{
	std::vector<double>  tempx(dim,0.0);
	int status = 0, k;
	double temp;
	if (lp.size() == 0)
	{
		for (k = 0; k < dim; ++k)
		{
			temp = pq.begin()->Pa->Pos[k] - xyz[k];
			pq_stats.xmin[k] = temp;
			pq_stats.xmax[k] = temp;
		}
		for (Neighbor* ngb = pq.begin(); ngb < pq.end(); ngb++)
		{
			for (k = 0; k < dim; ++k)
			{
				temp = ngb->Pa->Pos[k] - xyz[k];
				if (temp < pq_stats.xmin[k])
					pq_stats.xmin[k] = temp;
				if (temp > pq_stats.xmax[k])
					pq_stats.xmax[k] = temp;
				tempx[k]+=temp*temp;
			}
		}
	}
	else
	{
		for (k = 0; k < dim; ++k)
		{
			temp = periodic(pq.begin()->Pa->Pos[k] - xyz[k], lp[k]);
			pq_stats.xmin[k] = temp;
			pq_stats.xmax[k] = temp;
		}
		for (Neighbor* ngb = pq.begin(); ngb < pq.end(); ngb++)
		{
			for (k = 0; k < dim; ++k)
			{
				temp = periodic(ngb->Pa->Pos[k] - xyz[k], lp[k]);
				if (temp < pq_stats.xmin[k])
					pq_stats.xmin[k] = temp;
				if (temp > pq_stats.xmax[k])
					pq_stats.xmax[k] = temp;
				tempx[k]+=temp*temp;
			}
		}

	}

	temp = sqrt(pq.top().r);
	for (k = 0; k < dim; ++k)
	{
		pq_stats.metric[k] = temp / metric[k];
		tempx[k]=sqrt(tempx[k]/pq.size());

	}

//	return pq_stats.metric[0] / max(pq_stats.xmax[0], -pq_stats.xmin[0]);
//	std::cout<<tempx[0]<<" "<<max(pq_stats.xmax[0], -pq_stats.xmin[0])<<" "<<pq_stats.metric[0]<<" "<<pq_stats.metric[0]/tempx[0]<<std::endl;
//	return pq_stats.metric[0] /tempx[0];

	// new better improvement 24-2,2010
//	double coeff = dim * 2.5 / pow((1.0 * pq.size() - 2.0),(0.5+0.3/dim));
	double coeff = (1.5+0.25*dim+5.0/sqrt(1.0*pq.size()-2.75));
//	coeff=0.0;

	for (k = 0; k < dim; ++k)
	{
		if((pq_stats.metric[k] /tempx[k])> coeff)
			break;
//		temp = max(pq_stats.xmax[k], -pq_stats.xmin[k]) * coeff;
//		if (((pq_stats.xmin[k] + pq_stats.metric[k]) > temp)
//				&& ((pq_stats.metric[k] - pq_stats.xmax[k]) > temp))
	}

//	k=dim-1;

	if (k != dim)
	{
		status = 1;
		for (k = 0; k < dim; ++k)
		{
			//			std::cout<<pq_stats.xmax[k]<<" "<<pq_stats.xmin[k]<<std::endl;
//			if (pq_stats.xmax[k] != pq_stats.xmin[k])
//				metric[k] = 1.0 /tempx[k];
			if (pq_stats.xmax[k] != pq_stats.xmin[k])
				metric[k] = 2.0 / (pq_stats.xmax[k] - pq_stats.xmin[k]);
		}
	}

	//	std::cout<<status<<std::endl;
	return status;
}


int Tree::checkVol1(double* xyz,double* metric,ParticlePriorityQueue &pq)
{
	std::vector<double> xmean(dim,0.0);
	std::vector<double> xsig(dim,0.0);
	int status=0,k;
	for(k=0;k<dim;++k)
	{
		xmean[k]=pq.begin()->Pa->Pos[k]	 ;
		xsig[k]=pq.begin()->Pa->Pos[k]*pq.begin()->Pa->Pos[k]	 ;
	}
	for(Neighbor* ngb=pq.begin()+1;ngb<pq.end();ngb++)
	{
		for(k=0;k<dim;++k)
		{
			xmean[k]+=(ngb->Pa->Pos[k])	 ;
			xsig[k]+=(ngb->Pa->Pos[k])*(ngb->Pa->Pos[k])	 ;
		}
	}
	for(k=0;k<dim;++k)
	{
		xmean[k]/=(pq.end()-pq.begin())	 ;
		xsig[k]/=(pq.end()-pq.begin())	 ;
		xsig[k]=sqrt(xsig[k]-xmean[k]*xmean[k])	 ;
	}


	status=1;
	for(k=0;k<dim;++k)
		metric[k]=1/xsig[k];
	return status;
}


//void Tree::computeMetric(Particle* Part,double* metric,std::vector<class node_list> &box_list,pqStats &pq_stats)
void Tree::computeMetric(double* PartPos,double* metric,std::vector<class node_list> &box_list,pqStats &pq_stats)
{

	Node *cp;
	class node_list box;
	double temp1, temp2, temp3,temp4,r2=0.0;
	int j,k;
	//count3++;

	cp=root;
	while(cp->count()>1)
	{
	    if((PartPos[cp->get_kSplit()]) < cp->get_xSplit())
	    	cp=cp->leftN();
	    else
	    	cp=cp->rightN();
	}
//	while(cp->count()<100)
//		cp=cp->parent;

//	Node* cp1=cp;
	int count1=0;
	double fac=1.0;
//	for(int k=0;k<dim;++k)
	for(k=0;k<dim;++k)
	{
		pq_stats.searchx[k][0]=cp->bound(2*k);
		pq_stats.searchx[k][1]=cp->bound(2*k+1);
	}
	for(k=0;k<dim;k++)
		metric[k]=(pq_stats.searchx[k][1]-pq_stats.searchx[k][0])*0.5;

	for(k=0;k<dim;k++)
	{
		pq_stats.searchx[k][0]=cp->bound(2*k)-metric[k]*fac;
		pq_stats.searchx[k][1]=cp->bound(2*k+1)+metric[k]*fac;
	}


	box_list.clear();
	box.initialize(root,0.0);
	box_list.push_back(box);
	for(k=0;k<dim;k++)
		metric[k]=0.0;
//		count1=1;

	while (!box_list.empty())
	{
		cp=box_list.back().cp;
		box_list.pop_back();

		if (cp->count()>1)
		{
			k=cp->get_kSplit();

			if (cp->get_xSplit()<pq_stats.searchx[k][1])
			{
				box.initialize(cp->rightN(),r2);
				box_list.push_back(box);
			}
			if (cp->get_xSplit()>pq_stats.searchx[k][0])
			{
				box.initialize(cp->leftN(),r2);
				box_list.push_back(box);
			}
		}
		else
		{
			for(j=0; j<dim; ++j)
			{
			    temp1=pq_stats.searchx[j][0];    temp2=pq_stats.searchx[j][1];
			    temp3=cp->bound(2*j); temp4=cp->bound(2*j+1);
			    if(temp3>temp1)    temp1=temp3;
			    if(temp4<temp2)    temp2=temp4;
			    if(temp2<=temp1)
			    	break;
			}
			if(j==dim)
			{
//				temp=1.0;
//				for(j=0;j<dim;j++)
//					temp*=(cp->bound(2*j+1)-cp->bound(2*j));
//				temp=pow(temp,1.0/dim);
				for(j=0;j<dim;j++)
					metric[j]+=(cp->bound(2*j+1)-cp->bound(2*j));
//				for(j=0;j<dim;j++)
//					metric[j]+=(cp->bound(2*j+1)-cp->bound(2*j))*(cp->bound(2*j+1)-cp->bound(2*j))/(temp*temp);
				count1++;
//				count2++;
			}
//			std::cout<<(cp-root)+1<<" "<<cp->bnd[2*0]<<" "<<cp->bnd[2*1]<<" "<<cp->bnd[2*2]<<std::endl;
//			std::cout<<(cp-root)+1<<" "<<cp->bnd[2*0+1]<<" "<<cp->bnd[2*1+1]<<" "<<cp->bnd[2*2+1]<<std::endl;
		}
	}

	for(k=0;k<dim;k++)
		metric[k]=(count1/metric[k]);
//		metric[k]=sqrt(count1/metric[k]);

//	std::cout<<count1<<std::endl;
//	printv(Part->Pos,Part->Pos+6);
//	printv(&metric[0],&metric[0]+6);
//	exit(1);
	//	std::cout<<(cp1-root)+1<<" "<<count1<<" "<<"  "<<" "<<metric[0]<<" "<<metric[1]<<" "<<metric[2]<<std::endl;
//	std::cout<<" "<<Part->Pos[0]<<" "<<Part->Pos[1]<<" "<<Part->Pos[2]<<std::endl;
//	for(k=0;k<dim;k++)
//		std::cout<<pq_stats.searchx[k][0]<<" "<<pq_stats.searchx[k][1]<<std::endl;
//	for(k=0;k<dim;k++)
//		std::cout<<cp1->bound(2*k)<<" "<<cp1->bound(2*k+1)<<std::endl;
//	exit(1);
}


void Tree::smooth_quant(const double *searchcenter,int qBegin,int qEnd,std::vector<double> &quantMean,std::vector<class node_list> &box_list)
{
//	bool b1=0;
	int k;
	Node *cp;
	class node_list box;
//	double temp1, temp2,
	double r2=0.0;
	std::vector<Particle*> plist;
	double fnorm,kernel_norm=0.0;  //2d
//	kernel_norm=kernelNormFactor(3,dim);
	// 	std::cout<<cp<<" "<<box_list.size();
	double* metric=new double[dim];

	box_list.clear();
	box.initialize(root,0.0);
	box_list.push_back(box);

	while (!box_list.empty())
	{
		cp=box_list.back().cp;
		box_list.pop_back();

		if (cp->count()>numBucket)
		{
			k=cp->get_kSplit();

			if (cp->xb(0)>searchcenter[k])
			{
				box.initialize(cp->leftN(),r2);
				box_list.push_back(box);
				continue;
			}
			if (cp->xb(1)<searchcenter[k])
			{
				box.initialize(cp->leftN(),r2);
				box_list.push_back(box);
				continue;
			}
		}
		else
		{
			for (Particle* Part=cp->pFirst; Part<cp->pLast; Part++)
			{
				getMetric(Part,metric);
				r2=Part->distance_pq(searchcenter,metric,dim,1.0);
					if(r2<1.0)
					{
						fnorm=kernel_norm;
						for(int k=0;k<dim;++k)
						fnorm*=metric[k];
						for(int k=qBegin;k<qEnd;++k)
						quantMean[k]+=(1-r2)*Part->Pos[k]*Part->Mass(items)*fnorm/(Part->Density(items));
					}
			}
		}
	}

	delete [] metric;

}






