//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#include <algorithm>
#include <iterator>
#include <set>
#include <map>
#include <list>
#include <functional>
#include <numeric>
#include "ebfvector.hpp"
#include "gfextra.h"
#include "Functions.h"
#include "Timer.h"
#include "gfextra.h"


//int nmerge;
//std::vector<float> table_c,table_fc,table_b;

//ParametersGF AllG;
std::vector<GParticle> Par;
float global_mass=1.0;
//static int group_id,active_groups;


template<typename Container>
void display(const Container & c, std::string sep = " ")
{

    copy(c.begin(), c.end(), std::ostream_iterator<typename Container::value_type>(std::cout, sep.c_str()));
    std::cout << std::endl;
}

static int iloop;
//static double time1,time2,time3,time4;
//static double t1,t2;
void check_loop()
{
    iloop++;
    if(iloop>1000)
    {
	std::cout<<"looped"<<iloop<<" times. Cyclic parent list (ap)"<<std::endl;
	exit(1);
    }

}


class Group
{
public:
    bool status,mstatus,lstatus;
    int ID,parent,count;
    int li,vi;
    std::vector<int> plist;
    std::vector<int> sgplist;
    std::vector<int> sgplistp;
    double mass,vol,mass_vir,mass_ti;
    double fm,rp,volt;
    double PeakHeight;
    double rho_max,rho_min;  //only for test
    double* mrho;
// calculate memory and clear up  memory in vacant groups
    double mem()
	{
	    double memt=0.0;
	    if((plist.capacity()>1.2*plist.size())||(sgplist.capacity()>1.2*sgplist.size()))
	    {
		std::vector<int> tempv,tempv1,tempv2,tempv3;
		tempv=plist;
		plist.swap(tempv);
 		tempv1=sgplist;
 		sgplist.swap(tempv1);
//		pliste.clear(); tempv2=pliste; pliste.swap(tempv2);
		sgplistp.clear(); tempv3=sgplistp; sgplistp.swap(tempv3);
	    }
	    memt=((40+8+plist.capacity()+sgplist.capacity()+sgplistp.capacity())*4.0)/(1024.0*1024);
	    return memt;
	}
//    double mem1()
//	{
//	    double memt=0.0;
//	    if((plist.capacity()>2*plist.size())||(sgplist.capacity()>2*sgplist.size()))
//	    {
//		std::vector<int> tempv,tempv1,tempv2,tempv3;
//		tempv=plist;
//		plist.swap(tempv);
// 		tempv1=sgplist;
// 		sgplist.swap(tempv1);
////		pliste.clear(); tempv2=pliste; pliste.swap(tempv2);
//		sgplistp.clear(); tempv3=sgplistp; sgplistp.swap(tempv3);
//	    }
//	    memt=((40+8+plist.capacity()+sgplist.capacity()+sgplistp.capacity())*4.0)/(1024.0*1024);
//	    return memt;
//	}

    void calculate_tidal_mass(std::vector<class Group> &gpl,std::map<int,int> &id_gpP)
	{
	    class Group *gp1;
//	    double temp;
//	    int tempi=1;
	    double vol1=0.0,mass1=0.0;
	    std::vector<int>::iterator it1=sgplist.begin();

	    for(std::vector<int>::iterator it=plist.begin();it<plist.end();it++)
	    {
//	    	std::cout<<it-plist.begin()<<" a "<<plist.size()<<std::endl;
	    	mass1+=Par[*it].mass(); vol1+=Par[*it].mass()/Par[*it].Density;

		if(sgplist.size()>0)
		while(it1<sgplist.end())
		{
//	    	std::cout<<it1-sgplist.begin()<<" b "<<sgplist.size()<<std::endl;

			gp1=&gpl[id_gpP[*it1]];
		    if(Par[gp1->plist.back()].Density >Par[*it].Density)
		    {
		    	mass1+=gp1->mass; vol1+=gp1->vol;
		    	it1++;
		    }
		    else
		    	break;
		}

		if (vol1>volt)
		    break;
	    }

	    if(vol1 < volt)
		mass_ti=mass;
	    else
		mass_ti=mass1;

	}

    void check_subgroups(std::vector<class Group> &gpl,std::map<int,int> &id_gpP,ParametersGF &AllG)
	{
	    class Group *gp1;
	    double temp;
	    int tempi=1;

	    while(tempi)
	    {
		tempi=0;
		for(std::vector<int>::iterator it=sgplistp.begin();it<sgplistp.end();it++)
		{
		    gp1=&gpl[id_gpP[*it]];
		    if(gp1->status==1)
		    {
			temp=((gp1->rp-pow(vol/volume_d(3.0),1.0/AllG.dim))/pow(vol*gp1->fm/volume_d(3.0),1.0/AllG.dim));

			temp=temp/interpolate(float(log10(gp1->fm)),AllG.tb_fm,AllG.tb_cr);
//			gp1->cr=temp;

//			std::cout<<gp1->rp<<" "<<pow(vol*gp1->fm/volume_d(3.0),1.0/ND)<<"checking subgroups "<<pow(vol/volume_d(3.0),1.0/ND)<<" "<<temp<<std::endl;
		    if(temp<AllG.ContactRatio)
		    {
			gp1->attach_subgroup(gpl,id_gpP,AllG);
			tempi=1;
		    }
		    }
		}
	    }
	}


// make the status=0 for the group and add it to its parents list
// also check if its parent needs to be truncated
    void attach_subgroup(std::vector<class Group> &gpl,std::map<int,int> &id_gpP,ParametersGF &AllG)
	{
	    int i;
//	    double vol1;

	    check_loop();

	    if(status==0)
	    {
		std::cout<<"problem group already attached"<<std::endl;
		exit(1);
	    }

	    status=0;
	    i=id_gpP[parent];

            // find a group with open status and one which hasn't reached overdensity
	    while((gpl[i].status==0)&&(gpl[i].parent!=gpl[i].ID)  )
		i=id_gpP[gpl[i].parent];


	    if(gpl[i].mass/gpl[i].vol>AllG.Delta)
	    {
		if(gpl[i].status==1)
		{
		    parent=gpl[i].ID;
 		    gpl[i].sgplist.push_back(ID);
		    gpl[i].count+=count;
		    gpl[i].vol+=vol;
		    gpl[i].mass+=mass;
		    if(mass_vir==0.0)
			AllG.active_groups--;

//		    std::cout<<"attached"<<std::endl;
		    if(((gpl[i].mass/gpl[i].vol)<=AllG.Delta)&&(gpl[i].mass_vir==0.0))
		    {
			gpl[i].mass_vir=gpl[i].mass;
			gpl[i].vi=gpl[i].plist.size();
			AllG.active_groups--;
//			    std::cout<<AllG.Delta<<" "<<gpl[i].mass<<" "<<gpl[i].mass_vir<<std::endl;
		    }

		    if((AllG.SepCriteria==2)&&(gpl[i].parent!=gpl[i].ID)&&(gpl[i].vol>gpl[i].volt))
			gpl[i].attach_subgroup(gpl,id_gpP,AllG);


		}
		else
		{
		    std::cout<<"Warning parent truncated cannot attach group"<<std::endl;
		    std::cout<<gpl[i].ID<<" "<<gpl[i].parent<<" "<<id_gpP[gpl[i].ID]<<" "<<gpl[0].ID<<std::endl;
		    exit(10);
		}
	    }
	    else
	    {
		lstatus=1;
	    }
	}

    void calculate_peak_height(int i,ParametersGF &AllG)
	{
	    int count_p;
	    double temp=0.0; //,temp1;
	    count_p=int(plist.size());
 	    temp=log(Par[plist[0]].Density/Par[plist[count_p-1]].Density)/(AllG.sigma_rho);
//	    temp=log10(Par[plist[0]].Density/Par[plist[count_p-1]].Density)/(0.55/sqrt(AllG.DesNumNgb)); // for 3d old

 	    // only for test
 	    //---------
 	    rho_max=Par[plist[0]].Density;
 	    rho_min=Par[plist[count_p-1]].Density;
 	    if(AllG.VoxelsOn==1)
 	 	    temp=(Par[plist[0]].Density-Par[plist[count_p-1]].Density)/Par[plist[count_p-1]].Density;
 	    if(AllG.massDensityOn==1)
 	 	    temp=(Par[plist[0]].Density-Par[plist[count_p-1]].Density);


//---------
	    if(temp < 0)
		temp=0.0;

	    if((PeakHeight<AllG.PeakHeight)||(temp>AllG.PeakHeight))
		PeakHeight=temp;
	}




// add a particle to the group
    void add_particle(int i,std::vector<class Group> &gpl,std::map<int,int> &id_gpP,int option,ParametersGF &AllG)
	{
//	    bool b1=0;
//	    class Group* gpP1;

	    check_loop();

	    if(status)
	    {
		plist.push_back(i);
		Par[i].ID=ID;
		mass+=Par[i].mass();
		vol+=Par[i].mass()/Par[i].Density;
		count++;

		if(mass_vir==0.0)
		    calculate_peak_height(i,AllG);
		if((mass/(vol)<=AllG.Delta)&&(mass_vir==0.0))
		{
		    mass_vir=mass;
		    vi=plist.size();
		    AllG.active_groups--;
		}


		if((AllG.SepCriteria==1)&& ((mass/vol)>AllG.Delta))
		    check_subgroups(gpl,id_gpP,AllG);

		if((AllG.SepCriteria==2)&&(parent!=ID)&&(vol>volt))
		    attach_subgroup(gpl,id_gpP,AllG);
	    }
	    else
	    {
		if(ID!=parent)
		    gpl[id_gpP[parent]].add_particle(i,gpl,id_gpP,1,AllG);
		else
		{
		    std::cout<<"Warning parent truncated creating new group"<<std::endl;
		    std::cout<<ID<<" "<<parent<<" "<<id_gpP[ID]<<" "<<gpl[0].ID<<std::endl;
		    gpl[0].add_particle(i,gpl,id_gpP,1,AllG);
		    exit(10);
//		    create_group(gpl,i,id_gpP,0);
		}
	    }
	}



    void add_subgroup(class Group &gp1,std::vector<class Group> &gpl,std::map<int,int> &id_gpP,ParametersGF &AllG)
	{
//	    bool b1;
//	    class Group* gpP1;
	    check_loop();

	    if(status)
	    {
		if(gp1.mass_vir==0.0)
		    AllG.active_groups--;

//		AllG.active_groups--;
		int i;
		gp1.mstatus=1;
		for(std::vector<int>::iterator it=gp1.plist.begin();it!=gp1.plist.end();it++)
		{
		    i=*it;
		    plist.push_back(i);
		    Par[i].ID=ID;
		    count++;
		    mass+=Par[i].mass();	vol+=Par[i].mass()/Par[i].Density;
		}

		if(mass_vir==0.0)
		    calculate_peak_height(i,AllG);
		if((mass_vir==0.0)&&(mass/(vol)<=AllG.Delta))
		{
		    mass_vir=mass;
		    vi=plist.size();
		    AllG.active_groups--;
		}


		if((AllG.SepCriteria==1)&& ((mass/vol)>AllG.Delta))
		    check_subgroups(gpl,id_gpP,AllG);

		if((AllG.SepCriteria==2)&&(parent!=ID)&&(vol>volt))
		    attach_subgroup(gpl,id_gpP,AllG);


	    }
	    else
	    {
		if(ID!=parent)
		    gpl[id_gpP[parent]].add_subgroup(gp1,gpl,id_gpP,AllG);
		else
		{
		    std::cout<<"Warning parent truncated subgroup not added"<<std::endl;
		    std::cout<<ID<<" "<<parent<<" "<<id_gpP[ID]<<" "<<gpl[0].ID<<std::endl;
		    gpl[0].add_subgroup(gp1,gpl,id_gpP,AllG);
		    exit(10);
		}
	    }


	    std::vector<int> tempv;   gp1.plist.clear();	tempv=gp1.plist;   gp1.plist.swap(tempv);
	    std::vector<int> tempv1;  gp1.sgplist.clear(); tempv1=gp1.sgplist; gp1.sgplist.swap(tempv1);
	    std::vector<int> tempv3; gp1.sgplistp.clear(); tempv3=gp1.sgplistp; gp1.sgplistp.swap(tempv3);

	}


    bool operator<( const class Group &a ) const
	{
	    return count > a.count;
//	    return plist.size() > a.plist.size();
	}
    bool operator>( const class Group &a ) const
	{
	    return count < a.count;
//	    return plist.size() < a.plist.size();
	}

};


std::ostream& operator << (std::ostream& os, const class Group& s)
{
    std::cout<<s.ID<<" "<<"subgroups="<<s.sgplist.size()<<" "<<s.plist.size()<<" "<<s.status<<s.count<<std::endl;
//    display(s.gplist);
    return os;
}




// ostream& operator << (ostream& os, const class Plist& s)
// {

//     std::cout<<"pi="<<s.pi<<std::endl;
// //     for(int i=0;i<10;++i)
// // 	std::cout<<s.nlist[i].pi<<" ";

//     for(int i=0;i<10;++i)
// 	std::cout<<s.nlist[i]<<" ";
//     std::cout<<std::endl;
//     return os;
// }


void create_group(std::vector<class Group> &gpl,int i,std::map<int,int> &id_gpP,int option,ParametersGF &AllG)
{
    class Group gp;
    //    double area;
    //    area=3.14159*pow(double(Par[i].mass()/(Par[i].Density)),double((AllG.dim-1.0)/AllG.dim));
    //    area=1.0;

    gp.li=0;
    gp.vi=0;
    gp.mrho=NULL;

    gp.status=1;
    gp.mstatus=0;
    gp.lstatus=0;

    gp.count=0;
    gp.mass=0.0;
    gp.vol=0.0;
    gp.mass_vir=0.0;
    gp.mass_ti=0.0;
    gp.PeakHeight=0.0;
    gp.rp=0.0;
    gp.fm=0.0;
    gp.volt=0.0;
    gp.rho_max=0.0;
    gp.rho_min=0.0;

//    gp.cr=0.0;

    if(option==1)
    {
    	gp.ID=0;
    	AllG.group_id++;
    }
    else
    {
    	gp.ID=AllG.group_id;
    	AllG.active_groups++;
    	AllG.group_id++;
    }

    gp.parent=gp.ID;
    gpl.push_back(gp);
    id_gpP[gp.ID]=((&gpl.back())-(&gpl.front()));
    if(option==0)
	gpl.back().add_particle(i,gpl,id_gpP,0,AllG);

//	AllG.active_groups++;

//    if(Par[i].Density>AllG.Delta)
}



// make a new group add the particle to it and add the group to
//  "gpl" and  and update "id_gpP"


// find the closet two particles having higher density and their groups
// to gpi which is a unique list of groups return gpP_max
// check class Plist pl old or class Plist &pl new
void check_intersection(std::vector<class Group> &gpl,std::vector<class Group*> &gpi,const class Plist &pl,std::map<int,int> &id_gpP,class Group * &gpP_min,class Group * &gpP_max,double &voll,int pid,ParametersGF &AllG)
{
    double mass_max=0;
    class Group *gpP=NULL,*gpP0=NULL,*gpP1=NULL;
    class Group *gpP2=NULL;
    std::vector<class Group*>:: iterator it1;
    gpi.clear();
    int it;
//    for(std::vector<int>::iterator it=pl.nlist.begin();it<pl.nlist.end();it++)
    for(size_t i=0;i<pl.nlist.size();i++)
    {
	it=pl.nlist[i];

//	if(pid==2928459)
//	{
//    	std::cout<<"ngb loop i="<<i<<" ngbid"<<it<<" pid="<<pid<<" ngbsize="<<pl.nlist.size()<<" ngbID="<<Par[it].ID<<std::endl;
//    	std::cout<<"here "<<Par[*it].ID<<std::endl;
//	}
	if(Par[it].ID!=0)
	{

	    gpP=&gpl[id_gpP[Par[it].ID]];

	    while(gpP->status==0)
	    {
	    	gpP=&gpl[id_gpP[gpP->parent]];
//	    	if(pid==2928459)
//	    		std::cout<<gpP->ID<<" "<<gpP->status<<" "<<gpP->count<<" "<<gpP->mass<<" "<<gpP->vol<<" "<<gpP->parent<<std::endl;
	    }


	    it1=find(gpi.begin(),gpi.end(),gpP);
	    if(it1==gpi.end())
	    {
		gpi.push_back(gpP);
	    }

	    gpP2=gpP;
	    if(mass_max==0.0)
	    {
 		mass_max=gpP2->mass;
 		gpP_max=gpP2;
 		gpP_min=gpP2;
	    }

 	    if(gpP2->mass > mass_max)
 	    {
 		mass_max=gpP2->mass;
 		gpP_max=gpP2;
 	    }
	    else
 	    {
 		gpP_min=gpP2;
 	    }
	}




	if(gpi.size()==2)
	{

	    // check the root if same erase one from gpi
	    gpP0=gpi[0];
	    while(gpP0->parent!=gpP0->ID)
		gpP0=&gpl[id_gpP[gpP0->parent]];

	    gpP1=gpi[1];
	    while(gpP1->parent!=gpP1->ID)
		gpP1=&gpl[id_gpP[gpP1->parent]];

	    if((gpP0==gpP1)||(gpP_min->parent!=gpP_min->ID))
	    {
		gpi.pop_back();
	    }

	    break;
	}

    }


    if(gpi.size()>0)
    {
	gpi[0]->add_particle(pid,gpl,id_gpP,1,AllG);

    }
//	if(pid==2928459)
//		std::cout<<" "<<pid<<" "<<gpi.size()<<" "<<AllG.group_id<<std::endl;

}





//float calculate_r(int64_t offset,ExtBinFormat &ebf,int i1 ,int j1,class Group *gp,int flag_swap,ParametersGF &AllG)
//{
//    float posi[AllG.dim],dx[AllG.dim];
//    float posj[AllG.dim],temp=0.0,temp1=1.0;
//    int i,j,k,l,nrot;
//    int patternd[]={4,3,0};
//    float **mrho,*d,**ve;
//    d=fstd::vector(1,AllG.dim);  ve=matrix(1,AllG.dim,1,AllG.dim);  mrho=matrix(1,AllG.dim,1,AllG.dim);
//
//    patternd[0]=ebf.dataSize();
//    patternd[1]=ebf.dim(1);
//
//
//    if(AllG.GAnisotropyOn)
//    {
//
//	j=gp->plist[0];
////	fseek(fd,offset+ebf.dataSize()*ebf.dim(1)*j,SEEK_SET);
////	my_fread1(&posj[0],patternd,1,flag_swap,fd);
//	ebf.random_read(&posj[0],ebf.dataSize()*AllG.dim,(ebf.dataSize()*ebf.dim(1)*j+offset));
//
//
//	if((float(gp->plist.size())/(gp->li+1)-1.0)>0.1)
//	{
//	    for(i=gp->li;i<int(gp->plist.size());i++)
//	    {
//		for(k=0;k<AllG.dim;k++)
//		{
////		    fseek(fd,offset+ebf.dataSize()*ebf.dim(1)*gp->plist[i],SEEK_SET);
////		    my_fread1(&posi[0],patternd,1,flag_swap,fd);
//			ebf.random_read(&posi[0],ebf.dataSize()*AllG.dim,(ebf.dataSize()*ebf.dim(1)*gp->plist[i]+offset));
//		    dx[k]=(posi[k]-posj[k]);
//		}
//
//		j=0;
//		for(k=0;k<AllG.dim;k++)
//		    for(l=k;l<AllG.dim;l++)
//		    {
//			gp->mrho[j]+=dx[k]*dx[l]; j++;
//		    }
//	    }
//	    gp->li=int(gp->plist.size());
//	}
//
//	j=0;
//	for(k=1;k<=AllG.dim;k++)
//	    for(l=k;l<=AllG.dim;l++)
//	    {
//		mrho[k][l]=(gp->mrho[j])/gp->li;  j++;
//		if(l!=k)		mrho[l][k]=mrho[k][l];
//	    }
//
//
//
//	jacobi(mrho,AllG.dim,d,ve,&nrot);
//
//	temp=1.0;
//	for(k=1;k<=AllG.dim;k++)
//	{
//	    d[k]=fabs(sqrt(d[k]));
//	    temp*=d[k];
//	}
//	temp=pow(double(temp),double(1.0/AllG.dim));
//	for(k=1;k<=AllG.dim;k++)
//	    d[k]=d[k]/temp;
//
//  	for(k=1;k<=AllG.dim;k++)
//  	    std::cout<<k<<" ev "<<d[k]<<std::endl;
//
//
//    }
////--------------------
//
////    fseek(fd,offset+ebf.dataSize()*ebf.dim(1)*i1,SEEK_SET);
////    my_fread1(&posi[0],patternd,1,flag_swap,fd);
//	ebf.random_read(&posi[0],ebf.dataSize()*AllG.dim,(ebf.dataSize()*ebf.dim(1)*i1+offset));
////    fseek(fd,offset+ebf.dataSize()*ebf.dim(1)*j1,SEEK_SET);
////    my_fread1(&posj[0],patternd,1,flag_swap,fd);
//	ebf.random_read(&posj[0],ebf.dataSize()*AllG.dim,(ebf.dataSize()*ebf.dim(1)*j1+offset));
//
//    if(AllG.GAnisotropyOn)
//    {
//	    for(k=0,temp=0; k<AllG.dim; k++)
//	    {
//		for(l=0,temp1=0; l<AllG.dim; ++l)
//		{
//		    temp1+=(posi[l]-posj[l])*ve[l+1][k+1]/d[k+1];
//
//		}
//		temp+=temp1*temp1;
//	    }
//
//
//    }
//    else
//    {
//
//	for(k=0,temp=0.0;k<AllG.dim;k++)
//	    temp+=(posi[k]-posj[k])*(posi[k]-posj[k]);
//    }
//
//
////--------------------
//
////      std::cout<<"distance="<<sqrt(temp)<<std::endl;
////  	for(k=1;k<=ND;k++)
////  	    std::cout<<k<<" ev "<<d[k]<<std::endl;
//
//	free_fstd::vector(d, 1,AllG.dim);
//	free_matrix(ve,1,AllG.dim,1,AllG.dim);
//	free_matrix(mrho,1,AllG.dim,1,AllG.dim);
//
//
//    return sqrt(temp);
//}




int index(std::vector<int> &x,std::vector<int> &n,int i0,int i1,int i2)
{
	if(((x[1]+i1)>=n[1])||((x[2]+i1)<0))
		return -1;
	if(((x[2]+i2)>=n[2])||((x[2]+i2)<0))
		return -1;
	if((x[0]+i0)<0)
		i0+=n[0];
	return (x[2]+i2)*n[0]*n[1]+(x[1]+i1)*n[0]+((x[0]+i0)%n[0]);
}

void index_reverse(int i,std::vector<int> &n,std::vector<int> &x)
{
	x[0]=i%n[0];
	x[1]=(i/n[0])%n[1];
	x[2]=i/(n[0]*n[1]);
}

void gf(const char *filename, Parameters &All)
{
//	std::vector<class Plist*> pl;
	std::vector<class Plist> plv;
	ParametersGF AllG;

	std::cout << "Finding clusters" << std::endl;
	int i, pi = 0, p_size = 100, pi_1, NumPart; // ,j,k
	double temp;
	std::vector<class Group*> gpi;
	class Group* gpP_max, *gpP_min;
	class Group gp;
	std::vector<class Group> gpl;
	std::vector<class Group>::iterator it_bg;
	std::map<int, int> id_gpP;
	int nc;
	FILE* fd1;
//	int group_id = 1;
	AllG.initialize(All);

	//---------------------------------------------------------------
	std::cout<<std::scientific<<std::setw(16)<<"Delta"<<std::setw(16)<<AllG.Delta<<std::endl;
	std::cout<<std::setw(16)<<"RhoB"<<std::setw(16)<<AllG.RhoB<<std::endl;
	std::cout<<std::setw(16)<<std::fixed<<"PeakHeight"<<std::setw(12)<<AllG.PeakHeight<<std::endl;
	std::cout<<std::setw(16)<<"SepCriteria"<<std::setw(16)<<AllG.SepCriteria<<std::endl;
	std::cout<<std::setw(16)<<"Dimensions"<<std::setw(16)<<AllG.dim<<std::endl;

//	std::cout.precision(4);
//	std::cout << scientific << "Delta\t\t\t\t\t" << setw(12) << AllG.Delta <<std::endl;
//	std::cout << "RhoB\t\t\t\t\t" << setw(12) << AllG.RhoB <<std::endl;
//	std::cout << fixed << "PeakHeight\t\t\t\t" << setprecision(2) << setw(12)
//			<< AllG.PeakHeight <<std::endl;
//	std::cout <<"SepCriteria "<<AllG.SepCriteria<<std::endl;
//	std::cout.precision(1);

//	std::vector<class Plist>::iterator it;
	nc = 0;
	int nmerge;
	Plist itvoxels;
	Plist *it=&itvoxels;
	if(AllG.VoxelsOn==0)
	{
		load_plist1(filename, plv, Par, nmerge, NumPart, nc, fd1);
		it = &plv[0] - 1;
	}

	std::vector<int> sortedList;
	if(AllG.VoxelsOn==1)
	{
		char buf[512];
		sprintf(buf, "%s%s", AllG.InitCondFile, ".ebf");
		load_Par(buf,Par,NumPart,AllG.nx,sortedList);
		AllG.x=AllG.nx;
		itvoxels.nlist.resize(26,0);
	}

	AllG.setPeakHeight(NumPart);

	NumPart = int(Par.size());
	pi = NumPart / p_size - 1;
	pi_1 = NumPart / 10 - 1;
	Timer timer1;
	timer1.start();
//	load_table_fm(AllG.tb_fm,AllG.tb_cr);

	std::cout<<std::setw(16)<<std::fixed<< "NumPart"<<std::setw(16)<<Par.size()<<std::endl;
	//---------------------------------------------------------------


//	int flag_swap = 0;
	int64_t offset = 0;
	ebf::EbfFile ebf1;
//	FILE* fdp = NULL;
	if (AllG.SepCriteria == 1)
	{
		char buf[512];
		sprintf(buf, "%s%s", AllG.InitCondFile, ".ebf");
		ebf1.Open(buf,"/Pos3");
		if(ebf1.ecode!=0)
		{
			std::cout<<"Error opening file"<<std::endl;
			exit(1);
		}
	    if(AllG.dim>ebf1.dim(1))
	    {
	    	std::cout<<"AllG.dim greater than data dim"<<std::endl;
	    	exit(1);
	    }
//		fdp = ebf.fp();
//		if (fdp != NULL)
//			offset = ftell(fdp);
		if (ebf1.ecode == 0)
			offset = ebf1.Tell();
	}

	//    FILE* fdp=gadget_open(buf,flag_swap);
	//---------------------------------------------------------------
	//    pl.clear();
	//     for(std::vector<class Plist >:: iterator it=plv.begin();it<plv.end();++it)
	//     {
	// 	pl[it->pi]=&(*it);
	//     }

	//    sort(pl.begin(),pl.end(),cmp1);
	//        for(std::vector<class Plist*>:: iterator it=pl.begin();it<pl.end();++it)
	//  	    std::cout<<Par[(*it)->pi].Density<<std::endl;
	//---------------------------------------------------------------
	create_group(gpl, 0, id_gpP, 1,AllG);

	i = 0;
	pi = 0;
	std::cout<<"------------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::right<<std::setw(10)<<"% Done"<<std::setw(10)<<"Time Left"<<std::setw(10)<<"Est Time"<<std::setw(10)<<"Groups"<<std::setw(12)<<"Mem (MB)"<<std::setw(12)<<"Density"<<std::setw(12)<<"Active Grs"<<std::endl;
	std::cout<<"------------------------------------------------------------------------------"<<std::endl;
//	AllG.RhoB=100.0;
	for (i = 0; i < NumPart; ++i)
	{
//		std::cout<<i<<std::endl;

		if(AllG.VoxelsOn==0)
		{
		if (i == nc)
		{
			load_plist1(filename, plv, Par, nmerge, NumPart, nc, fd1);
//			it = plv.begin();
			it = &plv[0];
		}
		else
			it++;
		}

		if(AllG.VoxelsOn==1)
		{
			it->pi = sortedList[i];
			it->nlist.clear();
			index_reverse(it->pi,AllG.nx,AllG.x);
			for (int i1 = -1; i1 < 2; ++i1)
				for (int i2 = -1; i2 < 2; ++i2)
					for (int i3 = -1; i3 < 2; ++i3)
					{
						if ((i1 == 0) && (i2 == 0) && (i3 == 0))
							continue;
						int temp=index(AllG.x,AllG.nx,i1,i2,i3);
//						assert((temp<NumPart)&&(temp>=-1));
						if(temp>=0)
						{
							it->nlist.push_back(temp);
						}
					}
		}

		if ((Par[it->pi].Density) > AllG.RhoB)
		{
//			assert(it->nlist.size()>1);
//		    std::cout<<" size1 "<<it->nlist.size()<<std::endl;

			check_intersection(gpl, gpi, (*it), id_gpP, gpP_min, gpP_max, temp,
					it->pi,AllG);

			if (gpi.size() == 0)
			{
				create_group(gpl, it->pi, id_gpP, 0,AllG);
			}

			iloop = 0;
			if (gpi.size() > 1)
			{

				if (((gpi[1]->count < AllG.MinGpSize) || ((gpi[1]->PeakHeight)
						< AllG.PeakHeight)))
				// 		if((gpi[1]->count<AllG.MinGpSize)||(((gpi[1]->PeakHeight)<AllG.PeakHeight)&&(gpi[0]->count>=AllG.MinGpSize)&&(gpi[1]->PeakHeight<=gpi[0]->PeakHeight)))
				{

					if (((gpi[0]->count < AllG.MinGpSize)
							|| ((gpi[0]->PeakHeight) < AllG.PeakHeight))
							&& (gpi[0]->PeakHeight < gpi[1]->PeakHeight))
						gpi[1]->add_subgroup((*gpi[0]), gpl, id_gpP,AllG);
					else
						gpi[0]->add_subgroup((*gpi[1]), gpl, id_gpP,AllG);

				}
				else
				{

					if (((gpi[0]->count < AllG.MinGpSize)
							|| ((gpi[0]->PeakHeight) < AllG.PeakHeight)))
					// 		    if((gpi[0]->count<AllG.MinGpSize)||(((gpi[0]->PeakHeight)<AllG.PeakHeight)&&(gpi[1]->count>=All.MinGpSize)&&(gpi[0]->PeakHeight<gpi[1]->PeakHeight)))
					{
						gpi[1]->add_subgroup((*gpi[0]), gpl, id_gpP,AllG);
					}
					else
					{
						gpP_min->parent = gpP_max->ID;
						gpP_min->fm = gpP_min->mass / gpP_max->mass;

						if ((AllG.GAnisotropyOn) && (gpP_max->mrho == NULL))
						{
							gpP_max->mrho = new double[(AllG.dim * AllG.dim
									+ AllG.dim) / 2];
							for (int j = 0; j
									< (AllG.dim * AllG.dim + AllG.dim) / 2; j++)
								gpP_max->mrho[j] = 0.0;
						}
						//			gpP_min->volt=gpP_min->vol*pow(2.0,ND);
						gpP_min->volt = pow(pow(gpP_max->vol, 1.0 / AllG.dim)
								+ pow((gpP_min->vol), 1.0 / AllG.dim), AllG.dim
								* 1.0) * (gpP_min->mass / gpP_max->mass);

						gpP_max->sgplistp.push_back(gpP_min->ID);
						if (AllG.SepCriteria == 1)
						{
							std::cout<<"Sep criteria 1 not allowed"<<std::endl;
							exit(1);
//							gpP_min->rp = calculate_r(offset, ebf,
//									gpP_min->plist[0], gpP_max->plist[0],
//									gpP_max, flag_swap,AllG);
						}
						if (AllG.SepCriteria == 0)
							gpP_min->attach_subgroup(gpl, id_gpP,AllG);
					}

				}
			}
		}

		if ((AllG.active_groups == 0) && (AllG.Delta > 0))
			break;
		if (i == pi)
		{

			double memt = 0.0;
			for (std::vector<class Group>::iterator itg = gpl.begin(); itg
					< gpl.end(); ++itg)
			{
				memt += itg->mem();

			}
			if (AllG.Debug)
			{
				pi = pi + NumPart / p_size;
				//		t11=t22; t22=second();t00+=timediff(t11,t22);
//				printf(
//						"Evaluated = %3.1f %c Time Left = %f s of %f s Groups  = %d Mem=%f  Density=%7.2e Active Grs=%d\n",
//						((i + 1.0) * 100.0) / NumPart, '%',
//						timer1.currentTime() * (NumPart - i - 1) * 1.0
//								/ (i + 1), timer1.currentTime() * NumPart * 1.0
//								/ (i + 1), int(gpl.size()), memt,
//						Par[it->pi].Density, AllG.active_groups);
				//				fflush(stdout);
				std::cout<<std::right<<std::setw(10)<<std::fixed<<std::setprecision(0)<<((i + 1.0) * 100.0) / NumPart
					<<std::setw(10)<<std::setprecision(2)<<timer1.currentTime() * (NumPart - i - 1) * 1.0/(i + 1)
					<<std::setw(10)<<timer1.currentTime() * NumPart * 1.0/ (i + 1)
					<<std::setw(10)<<int(gpl.size())
					<<std::setw(12)<<std::scientific<<memt
					<<std::setw(12)<<Par[it->pi].Density
					<<std::setw(12)<<AllG.active_groups<<std::endl;
			}
		}

		//	i++;
	}
	std::cout<<"------------------------------------------------------------------------------"<<std::endl;
	std::cout<<std::left<<std::setprecision(6);

	if (AllG.SepCriteria == 1)
	{
		ebf1.Close();
	}

	pi = NumPart;
//	std::cout << "   Done " <<std::endl;
	//-------------------------------------------------------------------------------

	std::vector<class Group> gpl_t;
	gpl_t.clear();
	gpl_t = gpl;
	gpl.clear();
	//    std::cout<<"0 id "<<gpl_t[0].ID<<" "<<gpl_t[0].count<<std::endl;
	for (size_t i = 0; i < gpl_t.size(); i++)
	{
		if (gpl_t[i].mstatus == 0)
			gpl.push_back(gpl_t[i]);
	}
	id_gpP.clear();
	for (size_t i = 0; i < gpl.size(); ++i)
		id_gpP[gpl[i].ID] = i;
	gpl_t.clear();
	//    std::cout<<"0 id "<<gpl[0].ID<<" "<<gpl[0].count<<std::endl;


	//---------------------------------------------------------------
	//---------------------------------------------------------------
	// statistics
	i = 0;

	for (std::vector<class Group>::iterator itg = gpl.begin(); itg < gpl.end(); ++itg)
	{
		i += itg->plist.size();
	}

	//-------------------------------------------
	// add all remaining particles to backgound
	std::cout << "Adding remaining particles to background" << std::endl;
	for (int i=0;i<NumPart;++i)
	{
		if (Par[i].ID == 0)
		{
			iloop = 0;
			gpl[0].add_particle(i, gpl, id_gpP, 1,AllG);
		}
	}

	//-------------------------------------------
	std::cout << "Combining remaining groups to background" << std::endl;
	i = 0;
	// combine small remaining groups into background
	for (std::vector<class Group>::iterator itg = gpl.begin(); itg < gpl.end(); ++itg)
	{
		i += itg->plist.size();
		//	std::cout<<itg->ID<<" "<<itg->status<<" "<<itg->mstatus<<" "<<itg->parent<<" "<<itg->count<<" "<<itg->PeakHeight<<std::endl;
		if (((*itg).count < AllG.MinGpSize) || ((*itg).PeakHeight
				< AllG.PeakHeight))
		{
			if (itg->ID != 0)
			{
				if (itg->status != 1)
					exit(10);
				if (itg->status == 1)
				{
					iloop = 0;
					gpl[0].add_subgroup(*itg, gpl, id_gpP,AllG);
					itg->mstatus = 1;
				}
			}

		}
	}

	std::cout<< std::setw(36) << "Total Groups" << std::setw(12) << gpl.size() <<std::endl;
	std::cout<< std::setw(36) << "Total Particles" << std::setw(12) << NumPart <<std::endl;
	std::cout<< std::setw(36) << "Total Particles in groups" << std::setw(12) << i <<std::endl;
	//    display(gpl);
	//-------------------------------------------


	gpl_t.clear();
	gpl_t = gpl;
	gpl.clear();
	for (size_t i = 0; i < gpl_t.size(); i++)
	{
		if (gpl_t[i].mstatus == 0)
			gpl.push_back(gpl_t[i]);
	}
	id_gpP.clear();
	for (size_t i = 0; i < gpl.size(); ++i)
		id_gpP[gpl[i].ID] = i;
	gpl_t.clear();



	std::cout << "Sorting Groups according to mass and rename group ids" <<std::endl;
	sort(gpl.begin() + 1, gpl.end());



	//-------------------------------------------
	// rename the id of the groups
	//	std::cout << "Rename id of groups" <<std::endl;
	i = 0;
	std::map<int, int> id_map;
	for (std::vector<class Group>::iterator itg = gpl.begin(); itg < gpl.end(); ++itg)
	{

		if (itg->ID == 0)
		{
			id_map[itg->ID] = 0;
		}
		else
		{
			id_map[itg->ID] = (++i);
			itg->ID = i;
			for (std::vector<int>::iterator itg1 = itg->plist.begin(); itg1
					< itg->plist.end(); ++itg1)
			{
				//	        std::cout<<"here c"<<*itg1<<" "<<Par[*itg1].ID<<std::endl;
				Par[*itg1].ID = i;
				//	        std::cout<<"here b"<<*itg1<<" "<<Par[*itg1].ID<<std::endl;
			}
		}
	}

	for (std::vector<class Group>::iterator itg = gpl.begin(); itg < gpl.end(); ++itg)
	{

		itg->parent = id_map[itg->parent];
		for (std::vector<int>::iterator itg1 = itg->sgplist.begin(); itg1
				< itg->sgplist.end(); ++itg1)
		{
			*itg1 = id_map[(*itg1)];
		}
	}

	for (std::vector<class Group>::iterator itg = (gpl.begin() + 1); itg < gpl.end(); ++itg)
	{
		if (((itg->status) || (itg->lstatus)) && (itg->vi) && (itg->vi
				< int(itg->plist.size())))
		{
			for (std::vector<int>::iterator itg1 = itg->plist.begin() + itg->vi; itg1
					< itg->plist.end(); ++itg1)
			{
				iloop = 0;
				gpl[0].add_particle((*itg1), gpl, id_gpP, 1,AllG);
				itg->mass -= Par[*itg1].mass();
				itg->vol -= Par[*itg1].mass() / Par[*itg1].Density;
				itg->count--;
			}
			itg->plist.erase((itg->plist.begin() + itg->vi), itg->plist.end());
		}

	}

	id_gpP.clear();
	for (size_t i = 0; i < gpl.size(); ++i)
		id_gpP[gpl[i].ID] = i;
	//-------------------------------------------
	// check for overdensity and change status
	//		itg->calculate_mvir(itg->mass,itg->vol);
	//	    if((itg->status==0)&&(itg->vol_ti>itg->vol_2d)&&(itg->mass_2d!=0.0))

	// calculate the tidal mass
//	std::cout << "Calculate tidal mass" <<std::endl;

	for (std::vector<class Group>::iterator itg = (gpl.begin() + 1); itg < gpl.end(); ++itg)
	{
		if (itg->status == 0)
		{
			//	    std::cout<<"here b "<<itg-gpl.begin()<<" "<<gpl.size()<<std::endl;
			if (itg->vol > 1.01 * itg->volt)
				itg->calculate_tidal_mass(gpl, id_gpP);
			else
				itg->mass_ti = itg->mass;
		}
	}

//	std::cout << "Checking mass vir lstatus" <<std::endl;

	for (std::vector<class Group>::iterator itg = (gpl.begin() + 1); itg < gpl.end(); ++itg)
	{
		if (itg->status == 0)
		{
			if (itg->lstatus)
				itg->status = 1;
			else
				itg->mass_vir = 0.0;
		}

		if ((AllG.Delta == 0.0) && (itg->status == 1))
			itg->mass_vir = itg->mass;

	}

	//-------------------------------------------
	// write particles with group id

	char buf_gid[512];
	sprintf(buf_gid, "%s%s%s%s%s%s", AllG.InitCondFile, AllG.DeSuffix, "_den", AllG.GrSuffix, "_gid", ".ebf");
	{


		std::cout<<"Writing group ids of particles to file: "<<buf_gid<<std::endl;

		std::vector<int> vid(Par.size());
		std::vector<double> density(Par.size());
		for (size_t i = 0; i < Par.size(); ++i)
		  {
			vid[i] = Par[i].ID;
			density[i] = Par[i].Density;
		  }
		ebf::Write(buf_gid,"/label",&vid[0],"w","",vid.size());
		ebf::Write(buf_gid,"/density",&density[0],"a","",density.size());



	}


	// write group catalogue
	{
		int i = 0, tempi = 0;
		char buf[512];
		sprintf(buf, "%s%s%s%s%s%s", AllG.InitCondFile, AllG.DeSuffix,"_den", AllG.GrSuffix, "_grp", ".txt");


		// std::cout<<"Writing group info to file:"<<buf<<std::endl;

		std::cout<<std::endl<<"Summary of top 100 groups"<<std::endl;
		std::cout<<"-----------------------------------------------------------------------------"<<std::endl;

		//write your own output routine here
		// below is output in ascii format
		std::cout.precision(3);

		// std::ofstream fd(buf);
		std::vector<std::pair<std::string, int> > tags;
		tags.push_back(std::pair<std::string, int> ("id", 2));
		tags.push_back(std::pair<std::string, int> ("nsgp", 2));
		tags.push_back(std::pair<std::string, int> ("status", 2));
		tags.push_back(std::pair<std::string, int> ("isgp", 2));
		tags.push_back(std::pair<std::string, int> ("iden", 2));
		tags.push_back(std::pair<std::string, int> ("count", 2));
		tags.push_back(std::pair<std::string, int> ("parent", 2));
		tags.push_back(std::pair<std::string, int> ("sig", 4));
		tags.push_back(std::pair<std::string, int> ("mass", 4));
		tags.push_back(std::pair<std::string, int> ("mass_vir", 4));
		tags.push_back(std::pair<std::string, int> ("vol", 4));
		tags.push_back(std::pair<std::string, int> ("cr", 4));
		tags.push_back(std::pair<std::string, int> ("rho_max", 4));
		tags.push_back(std::pair<std::string, int> ("rho_min", 4));

		std::vector<int64_t> gid;
		std::vector<int64_t> nsgp;
		std::vector<int64_t> status;
		std::vector<int64_t> isgp;
		std::vector<int64_t> iden;
		std::vector<int64_t> count;
		std::vector<int64_t> parent;
		std::vector<double> sig;
		std::vector<double> mass;
		std::vector<double> mass_vir;
		std::vector<double> vol;
		std::vector<double> cr;
		std::vector<double> rho_max;
		std::vector<double> rho_min;

		//		if (fd.is_open())
		if (true)
		{
			// fd << gpl.size() << "\t" << tags.size() <<std::endl;
			// for (size_t j = 0; j < tags.size(); j++)
			// {
			// 	fd << std::setw(12) << tags[j].first;
			// }
			std::cout<<std::right<< std::setw(8) << tags[0].first;
			std::cout << std::setw(8) << tags[1].first;
			std::cout << std::setw(8) << tags[2].first;
			for (size_t j = 3; j < 8; j++)
				std::cout << std::setw(10) << tags[j].first;
			std::cout <<std::endl;
			std::cout<<"-----------------------------------------------------------------------------"<<std::endl;

			// fd <<std::endl;
			// for (size_t j = 0; j < tags.size(); j++)
			// 	fd << std::setw(12) << tags[j].second;
			// fd <<std::endl;



			for (std::vector<class Group>::iterator itg = gpl.begin(); itg
					< gpl.end(); ++itg)
			{

				if (itg->plist.size() == 0)
					tempi = -1;
				else
					tempi = itg->plist[0];

				gid.push_back(itg->ID);
				nsgp.push_back(itg->sgplist.size());
				status.push_back(itg->status);
				isgp.push_back(i);
				iden.push_back(tempi);
				count.push_back(itg->plist.size());
				parent.push_back(itg->parent);
				sig.push_back(itg->PeakHeight);
				mass.push_back(itg->mass);
				mass_vir.push_back(itg->mass_vir);
			        vol.push_back(itg->vol);
				cr.push_back(itg->mass_ti);
				rho_max.push_back(itg->rho_max);
			        rho_min.push_back(itg->rho_min);

				// fd << std::fixed << std::setw(12) << itg->ID << std::setw(12)
				//    << itg->sgplist.size() << std::setw(12) << itg->status
				//    << std::setw(12) << i << std::setw(12) << tempi 
				//    << std::setw(12)
				//    << itg->plist.size() << std::setw(12) << itg->parent
				//    << std::setw(12) << std::setprecision(2)
				//    << float(itg->PeakHeight) << std::scientific
				//    << std::setprecision(4) << std::setw(12) << float(itg->mass)
				//    << std::setw(12) << float(itg->mass_vir) << std::setw(12)
				//    << float(itg->vol) << std::setw(12) << itg->mass_ti 
				//    << std::setw(12) << itg->rho_max << std::setw(12) 
				//    << itg->rho_min <<std::endl;

				i += itg->sgplist.size();

				if (AllG.Debug)
				  if((itg-gpl.begin())<100)
				    {
					std::cout<<std::setw(8)<<std::fixed<<itg->ID
						<<std::setw(8)<<itg->sgplist.size()
						<<std::setw(8)<<itg->status
						<<std::setw(10) << i
						<<std::setw(10) << tempi
						<<std::setw(10)<<itg->plist.size()
						<<std::setw(10)<< itg->parent
						<<std::setw(10) << std::setprecision(2)<<std::scientific<<float(itg->PeakHeight)
						<<std::endl;
				    }
			}

			if (gid.size()> 0)
			  {
			    ebf::Write(buf_gid,"/clusters/label",&gid[0],"a","",gid.size());
			    ebf::Write(buf_gid,"/clusters/nsgp",&nsgp[0],"a","",nsgp.size());
			    ebf::Write(buf_gid,"/clusters/status",&status[0],"a","",status.size());
			    ebf::Write(buf_gid,"/clusters/isgp",&isgp[0],"a","",isgp.size());
			    ebf::Write(buf_gid,"/clusters/iden",&iden[0],"a","",iden.size());
			    ebf::Write(buf_gid,"/clusters/count",&count[0],"a","",count.size());
			    ebf::Write(buf_gid,"/clusters/parent",&parent[0],"a","",parent.size());
			    ebf::Write(buf_gid,"/clusters/sig",&sig[0],"a","",sig.size());
			    ebf::Write(buf_gid,"/clusters/mass",&mass[0],"a","",mass.size());
			    ebf::Write(buf_gid,"/clusters/mass_vir",&mass_vir[0],"a","",mass_vir.size());
			    ebf::Write(buf_gid,"/clusters/vol",&vol[0],"a","",vol.size());
			    ebf::Write(buf_gid,"/clusters/cr",&cr[0],"a","",cr.size());
			    ebf::Write(buf_gid,"/clusters/rho_max",&rho_max[0],"a","",rho_max.size());
			    ebf::Write(buf_gid,"/clusters/rho_min",&rho_min[0],"a","",rho_min.size());
			  }

			std::vector<int64_t> sgplist;
			for (std::vector<class Group>::iterator itg = gpl.begin(); itg < gpl.end(); ++itg)
			{
				for (std::vector<int>::iterator itg1 = itg->sgplist.begin(); itg1
						< itg->sgplist.end(); ++itg1)
				{
					// fd << *itg1 << " ";
                                        sgplist.push_back(*itg1);
				}
			}
			// fd <<std::endl;
			// fd.close();
			if (sgplist.size()> 0)
			  {
			    ebf::Write(buf_gid,"/sgplist",&sgplist[0],"a","",sgplist.size());
			  }

		}
		std::cout<<"-----------------------------------------------------------------------------"<<std::endl;


	}



}


